/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.96 Revision 1.440
1# Copyright 1999-2004 Gentoo Foundation 1# Copyright 1999-2014 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.96 2004/08/24 11:51:28 lv Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.440 2014/11/15 09:49:10 vapier Exp $
4#
5# Author: Martin Schlemmer <azarah@gentoo.org>
6#
7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves.
9#
10# NB: If you add anything, please comment it!
11 4
12ECLASS=eutils 5# @ECLASS: eutils.eclass
13INHERITED="$INHERITED $ECLASS" 6# @MAINTAINER:
14 7# base-system@gentoo.org
15DEPEND="!bootstrap? ( sys-devel/patch )" 8# @BLURB: many extra (but common) functions that are used in ebuilds
16 9# @DESCRIPTION:
17DESCRIPTION="Based on the ${ECLASS} eclass" 10# The eutils eclass contains a suite of functions that complement
18 11# the ones that ebuild.sh already contain. The idea is that the functions
19# This function simply returns the desired lib directory. With portage 12# are not required in all ebuilds but enough utilize them to have a common
20# 2.0.51, we now have support for installing libraries to lib32/lib64 13# home rather than having multiple ebuilds implementing the same thing.
21# to accomidate the needs of multilib systems. It's no longer a good idea
22# to assume all libraries will end up in lib. Replace any (sane) instances
23# where lib is named directly with $(get_libdir) if possible.
24# 14#
25# Travis Tilley <lv@gentoo.org> (24 Aug 2004) 15# Due to the nature of this eclass, some functions may have maintainers
26get_libdir() { 16# different from the overall eclass!
27 # CONF_LIBDIR wasnt supported until 2.0.51_pre18, so for all versions of
28 # portage prior to that lib would need to be used even if CONF_LIBDIR is
29 # set. dolib and friends will ignore CONF_LIBDIR in <2.0.51_pre20
30 portageq has_version / '<sys-apps/portage-2.0.51_pre20' && CONF_LIBDIR="lib"
31 # and of course, we need to default to lib when CONF_LIBDIR isnt set
32 echo ${CONF_LIBDIR:=lib}
33}
34 17
35# This function generate linker scripts in /usr/lib for dynamic 18if [[ -z ${_EUTILS_ECLASS} ]]; then
36# libs in /lib. This is to fix linking problems when you have 19_EUTILS_ECLASS=1
37# the .so in /lib, and the .a in /usr/lib. What happens is that
38# in some cases when linking dynamic, the .a in /usr/lib is used
39# instead of the .so in /lib due to gcc/libtool tweaking ld's
40# library search path. This cause many builds to fail.
41# See bug #4411 for more info.
42#
43# To use, simply call:
44#
45# gen_usr_ldscript libfoo.so
46#
47# Note that you should in general use the unversioned name of
48# the library, as ldconfig should usually update it correctly
49# to point to the latest version of the library present.
50#
51# <azarah@gentoo.org> (26 Oct 2002)
52#
53gen_usr_ldscript() {
54 # Just make sure it exists
55 dodir /usr/$(get_libdir)
56 20
57 cat > ${D}/usr/$(get_libdir)/$1 <<"END_LDSCRIPT" 21inherit multilib toolchain-funcs
58/* GNU ld script
59 Because Gentoo have critical dynamic libraries
60 in /lib, and the static versions in /usr/lib, we
61 need to have a "fake" dynamic lib in /usr/lib,
62 otherwise we run into linking problems.
63 See bug #4411 on http://bugs.gentoo.org/ for
64 more info. */
65END_LDSCRIPT
66 22
67 echo "GROUP ( /$(get_libdir)/libxxx )" >> ${D}/usr/$(get_libdir)/$1 23if has "${EAPI:-0}" 0 1 2; then
68 dosed "s:libxxx:$1:" /usr/$(get_libdir)/$1
69 24
25# @FUNCTION: epause
26# @USAGE: [seconds]
27# @DESCRIPTION:
28# Sleep for the specified number of seconds (default of 5 seconds). Useful when
29# printing a message the user should probably be reading and often used in
30# conjunction with the ebeep function. If the EPAUSE_IGNORE env var is set,
31# don't wait at all. Defined in EAPIs 0 1 and 2.
32epause() {
33 [[ -z ${EPAUSE_IGNORE} ]] && sleep ${1:-5}
34}
35
36# @FUNCTION: ebeep
37# @USAGE: [number of beeps]
38# @DESCRIPTION:
39# Issue the specified number of beeps (default of 5 beeps). Useful when
40# printing a message the user should probably be reading and often used in
41# conjunction with the epause function. If the EBEEP_IGNORE env var is set,
42# don't beep at all. Defined in EAPIs 0 1 and 2.
43ebeep() {
44 local n
45 if [[ -z ${EBEEP_IGNORE} ]] ; then
46 for ((n=1 ; n <= ${1:-5} ; n++)) ; do
47 echo -ne "\a"
48 sleep 0.1 &>/dev/null ; sleep 0,1 &>/dev/null
49 echo -ne "\a"
50 sleep 1
51 done
52 fi
53}
54
55else
56
57ebeep() {
58 ewarn "QA Notice: ebeep is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
59}
60
61epause() {
62 ewarn "QA Notice: epause is not defined in EAPI=${EAPI}, please file a bug at http://bugs.gentoo.org"
63}
64
65fi
66
67# @FUNCTION: eqawarn
68# @USAGE: [message]
69# @DESCRIPTION:
70# Proxy to ewarn for package managers that don't provide eqawarn and use the PM
71# implementation if available. Reuses PORTAGE_ELOG_CLASSES as set by the dev
72# profile.
73if ! declare -F eqawarn >/dev/null ; then
74 eqawarn() {
75 has qa ${PORTAGE_ELOG_CLASSES} && ewarn "$@"
76 :
77 }
78fi
79
80# @FUNCTION: ecvs_clean
81# @USAGE: [list of dirs]
82# @DESCRIPTION:
83# Remove CVS directories recursiveley. Useful when a source tarball contains
84# internal CVS directories. Defaults to $PWD.
85ecvs_clean() {
86 [[ -z $* ]] && set -- .
87 find "$@" -type d -name 'CVS' -prune -print0 | xargs -0 rm -rf
88 find "$@" -type f -name '.cvs*' -print0 | xargs -0 rm -rf
89}
90
91# @FUNCTION: esvn_clean
92# @USAGE: [list of dirs]
93# @DESCRIPTION:
94# Remove .svn directories recursiveley. Useful when a source tarball contains
95# internal Subversion directories. Defaults to $PWD.
96esvn_clean() {
97 [[ -z $* ]] && set -- .
98 find "$@" -type d -name '.svn' -prune -print0 | xargs -0 rm -rf
99}
100
101# @FUNCTION: estack_push
102# @USAGE: <stack> [items to push]
103# @DESCRIPTION:
104# Push any number of items onto the specified stack. Pick a name that
105# is a valid variable (i.e. stick to alphanumerics), and push as many
106# items as you like onto the stack at once.
107#
108# The following code snippet will echo 5, then 4, then 3, then ...
109# @CODE
110# estack_push mystack 1 2 3 4 5
111# while estack_pop mystack i ; do
112# echo "${i}"
113# done
114# @CODE
115estack_push() {
116 [[ $# -eq 0 ]] && die "estack_push: incorrect # of arguments"
117 local stack_name="_ESTACK_$1_" ; shift
118 eval ${stack_name}+=\( \"\$@\" \)
119}
120
121# @FUNCTION: estack_pop
122# @USAGE: <stack> [variable]
123# @DESCRIPTION:
124# Pop a single item off the specified stack. If a variable is specified,
125# the popped item is stored there. If no more items are available, return
126# 1, else return 0. See estack_push for more info.
127estack_pop() {
128 [[ $# -eq 0 || $# -gt 2 ]] && die "estack_pop: incorrect # of arguments"
129
130 # We use the fugly _estack_xxx var names to avoid collision with
131 # passing back the return value. If we used "local i" and the
132 # caller ran `estack_pop ... i`, we'd end up setting the local
133 # copy of "i" rather than the caller's copy. The _estack_xxx
134 # garbage is preferable to using $1/$2 everywhere as that is a
135 # bit harder to read.
136 local _estack_name="_ESTACK_$1_" ; shift
137 local _estack_retvar=$1 ; shift
138 eval local _estack_i=\${#${_estack_name}\[@\]}
139 # Don't warn -- let the caller interpret this as a failure
140 # or as normal behavior (akin to `shift`)
141 [[ $(( --_estack_i )) -eq -1 ]] && return 1
142
143 if [[ -n ${_estack_retvar} ]] ; then
144 eval ${_estack_retvar}=\"\${${_estack_name}\[${_estack_i}\]}\"
145 fi
146 eval unset ${_estack_name}\[${_estack_i}\]
147}
148
149# @FUNCTION: evar_push
150# @USAGE: <variable to save> [more vars to save]
151# @DESCRIPTION:
152# This let's you temporarily modify a variable and then restore it (including
153# set vs unset semantics). Arrays are not supported at this time.
154#
155# This is meant for variables where using `local` does not work (such as
156# exported variables, or only temporarily changing things in a func).
157#
158# For example:
159# @CODE
160# evar_push LC_ALL
161# export LC_ALL=C
162# ... do some stuff that needs LC_ALL=C set ...
163# evar_pop
164#
165# # You can also save/restore more than one var at a time
166# evar_push BUTTERFLY IN THE SKY
167# ... do stuff with the vars ...
168# evar_pop # This restores just one var, SKY
169# ... do more stuff ...
170# evar_pop 3 # This pops the remaining 3 vars
171# @CODE
172evar_push() {
173 local var val
174 for var ; do
175 [[ ${!var+set} == "set" ]] \
176 && val=${!var} \
177 || val="unset_76fc3c462065bb4ca959f939e6793f94"
178 estack_push evar "${var}" "${val}"
179 done
180}
181
182# @FUNCTION: evar_push_set
183# @USAGE: <variable to save> [new value to store]
184# @DESCRIPTION:
185# This is a handy shortcut to save and temporarily set a variable. If a value
186# is not specified, the var will be unset.
187evar_push_set() {
188 local var=$1
189 evar_push ${var}
190 case $# in
191 1) unset ${var} ;;
192 2) printf -v "${var}" '%s' "$2" ;;
193 *) die "${FUNCNAME}: incorrect # of args: $*" ;;
194 esac
195}
196
197# @FUNCTION: evar_pop
198# @USAGE: [number of vars to restore]
199# @DESCRIPTION:
200# Restore the variables to the state saved with the corresponding
201# evar_push call. See that function for more details.
202evar_pop() {
203 local cnt=${1:-bad}
204 case $# in
205 0) cnt=1 ;;
206 1) isdigit "${cnt}" || die "${FUNCNAME}: first arg must be a number: $*" ;;
207 *) die "${FUNCNAME}: only accepts one arg: $*" ;;
208 esac
209
210 local var val
211 while (( cnt-- )) ; do
212 estack_pop evar val || die "${FUNCNAME}: unbalanced push"
213 estack_pop evar var || die "${FUNCNAME}: unbalanced push"
214 [[ ${val} == "unset_76fc3c462065bb4ca959f939e6793f94" ]] \
215 && unset ${var} \
216 || printf -v "${var}" '%s' "${val}"
217 done
218}
219
220# @FUNCTION: eshopts_push
221# @USAGE: [options to `set` or `shopt`]
222# @DESCRIPTION:
223# Often times code will want to enable a shell option to change code behavior.
224# Since changing shell options can easily break other pieces of code (which
225# assume the default state), eshopts_push is used to (1) push the current shell
226# options onto a stack and (2) pass the specified arguments to set.
227#
228# If the first argument is '-s' or '-u', we assume you want to call `shopt`
229# rather than `set` as there are some options only available via that.
230#
231# A common example is to disable shell globbing so that special meaning/care
232# may be used with variables/arguments to custom functions. That would be:
233# @CODE
234# eshopts_push -o noglob
235# for x in ${foo} ; do
236# if ...some check... ; then
237# eshopts_pop
238# return 0
239# fi
240# done
241# eshopts_pop
242# @CODE
243eshopts_push() {
244 if [[ $1 == -[su] ]] ; then
245 estack_push eshopts "$(shopt -p)"
246 [[ $# -eq 0 ]] && return 0
247 shopt "$@" || die "${FUNCNAME}: bad options to shopt: $*"
248 else
249 estack_push eshopts $-
250 [[ $# -eq 0 ]] && return 0
251 set "$@" || die "${FUNCNAME}: bad options to set: $*"
252 fi
253}
254
255# @FUNCTION: eshopts_pop
256# @USAGE:
257# @DESCRIPTION:
258# Restore the shell options to the state saved with the corresponding
259# eshopts_push call. See that function for more details.
260eshopts_pop() {
261 local s
262 estack_pop eshopts s || die "${FUNCNAME}: unbalanced push"
263 if [[ ${s} == "shopt -"* ]] ; then
264 eval "${s}" || die "${FUNCNAME}: sanity: invalid shopt options: ${s}"
265 else
266 set +$- || die "${FUNCNAME}: sanity: invalid shell settings: $-"
267 set -${s} || die "${FUNCNAME}: sanity: unable to restore saved shell settings: ${s}"
268 fi
269}
270
271# @FUNCTION: eumask_push
272# @USAGE: <new umask>
273# @DESCRIPTION:
274# Set the umask to the new value specified while saving the previous
275# value onto a stack. Useful for temporarily changing the umask.
276eumask_push() {
277 estack_push eumask "$(umask)"
278 umask "$@" || die "${FUNCNAME}: bad options to umask: $*"
279}
280
281# @FUNCTION: eumask_pop
282# @USAGE:
283# @DESCRIPTION:
284# Restore the previous umask state.
285eumask_pop() {
286 [[ $# -eq 0 ]] || die "${FUNCNAME}: we take no options"
287 local s
288 estack_pop eumask s || die "${FUNCNAME}: unbalanced push"
289 umask ${s} || die "${FUNCNAME}: sanity: could not restore umask: ${s}"
290}
291
292# @FUNCTION: isdigit
293# @USAGE: <number> [more numbers]
294# @DESCRIPTION:
295# Return true if all arguments are numbers.
296isdigit() {
297 local d
298 for d ; do
299 [[ ${d:-bad} == *[!0-9]* ]] && return 1
300 done
70 return 0 301 return 0
71} 302}
72 303
73# Simple function to draw a line consisting of '=' the same length as $* 304# @VARIABLE: EPATCH_SOURCE
74# 305# @DESCRIPTION:
75# <azarah@gentoo.org> (11 Nov 2002) 306# Default directory to search for patches.
76#
77draw_line() {
78 local i=0
79 local str_length=""
80
81 # Handle calls that do not have args, or wc not being installed ...
82 if [ -z "$1" -o ! -x "$(which wc 2>/dev/null)" ]
83 then
84 echo "==============================================================="
85 return 0
86 fi
87
88 # Get the length of $*
89 str_length="$(echo -n "$*" | wc -m)"
90
91 while [ "$i" -lt "${str_length}" ]
92 do
93 echo -n "="
94
95 i=$((i + 1))
96 done
97
98 echo
99
100 return 0
101}
102
103# Default directory where patches are located
104EPATCH_SOURCE="${WORKDIR}/patch" 307EPATCH_SOURCE="${WORKDIR}/patch"
105# Default extension for patches 308# @VARIABLE: EPATCH_SUFFIX
309# @DESCRIPTION:
310# Default extension for patches (do not prefix the period yourself).
106EPATCH_SUFFIX="patch.bz2" 311EPATCH_SUFFIX="patch.bz2"
107# Default options for patch 312# @VARIABLE: EPATCH_OPTS
108# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 313# @DESCRIPTION:
314# Options to pass to patch. Meant for ebuild/package-specific tweaking
315# such as forcing the patch level (-p#) or fuzz (-F#) factor. Note that
316# for single patch tweaking, you can also pass flags directly to epatch.
109EPATCH_OPTS="-g0" 317EPATCH_OPTS=""
318# @VARIABLE: EPATCH_COMMON_OPTS
319# @DESCRIPTION:
320# Common options to pass to `patch`. You probably should never need to
321# change these. If you do, please discuss it with base-system first to
322# be sure.
323# @CODE
324# -g0 - keep RCS, ClearCase, Perforce and SCCS happy #24571
325# --no-backup-if-mismatch - do not leave .orig files behind
326# -E - automatically remove empty files
327# @CODE
328EPATCH_COMMON_OPTS="-g0 -E --no-backup-if-mismatch"
329# @VARIABLE: EPATCH_EXCLUDE
330# @DESCRIPTION:
110# List of patches not to apply. Not this is only file names, 331# List of patches not to apply. Note this is only file names,
111# and not the full path .. 332# and not the full path. Globs accepted.
112EPATCH_EXCLUDE="" 333EPATCH_EXCLUDE=""
334# @VARIABLE: EPATCH_SINGLE_MSG
335# @DESCRIPTION:
113# Change the printed message for a single patch. 336# Change the printed message for a single patch.
114EPATCH_SINGLE_MSG="" 337EPATCH_SINGLE_MSG=""
115# Force applying bulk patches even if not following the style: 338# @VARIABLE: EPATCH_MULTI_MSG
116# 339# @DESCRIPTION:
117# ??_${ARCH}_foo.${EPATCH_SUFFIX} 340# Change the printed message for multiple patches.
118# 341EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
342# @VARIABLE: EPATCH_FORCE
343# @DESCRIPTION:
344# Only require patches to match EPATCH_SUFFIX rather than the extended
345# arch naming style.
119EPATCH_FORCE="no" 346EPATCH_FORCE="no"
347# @VARIABLE: EPATCH_USER_EXCLUDE
348# @DEFAULT_UNSET
349# @DESCRIPTION:
350# List of patches not to apply. Note this is only file names,
351# and not the full path. Globs accepted.
120 352
121# This function is for bulk patching, or in theory for just one 353# @FUNCTION: epatch
122# or two patches. 354# @USAGE: [options] [patches] [dirs of patches]
355# @DESCRIPTION:
356# epatch is designed to greatly simplify the application of patches. It can
357# process patch files directly, or directories of patches. The patches may be
358# compressed (bzip/gzip/etc...) or plain text. You generally need not specify
359# the -p option as epatch will automatically attempt -p0 to -p4 until things
360# apply successfully.
123# 361#
124# It should work with .bz2, .gz, .zip and plain text patches. 362# If you do not specify any patches/dirs, then epatch will default to the
125# Currently all patches should be the same format. 363# directory specified by EPATCH_SOURCE.
126# 364#
127# You do not have to specify '-p' option to patch, as it will 365# Any options specified that start with a dash will be passed down to patch
128# try with -p0 to -p5 until it succeed, or fail at -p5. 366# for this specific invocation. As soon as an arg w/out a dash is found, then
367# arg processing stops.
129# 368#
130# Above EPATCH_* variables can be used to control various defaults, 369# When processing directories, epatch will apply all patches that match:
131# bug they should be left as is to ensure an ebuild can rely on 370# @CODE
132# them for. 371# if ${EPATCH_FORCE} != "yes"
133#
134# Patches are applied in current directory.
135#
136# Bulk Patches should preferibly have the form of:
137#
138# ??_${ARCH}_foo.${EPATCH_SUFFIX} 372# ??_${ARCH}_foo.${EPATCH_SUFFIX}
373# else
374# *.${EPATCH_SUFFIX}
375# @CODE
376# The leading ?? are typically numbers used to force consistent patch ordering.
377# The arch field is used to apply patches only for the host architecture with
378# the special value of "all" means apply for everyone. Note that using values
379# other than "all" is highly discouraged -- you should apply patches all the
380# time and let architecture details be detected at configure/compile time.
139# 381#
140# For example: 382# If EPATCH_SUFFIX is empty, then no period before it is implied when searching
383# for patches to apply.
141# 384#
142# 01_all_misc-fix.patch.bz2 385# Refer to the other EPATCH_xxx variables for more customization of behavior.
143# 02_sparc_another-fix.patch.bz2
144#
145# This ensures that there are a set order, and you can have ARCH
146# specific patches.
147#
148# If you however give an argument to epatch(), it will treat it as a
149# single patch that need to be applied if its a file. If on the other
150# hand its a directory, it will set EPATCH_SOURCE to this.
151#
152# <azarah@gentoo.org> (10 Nov 2002)
153#
154epatch() { 386epatch() {
155 local PIPE_CMD="" 387 _epatch_draw_line() {
156 local STDERR_TARGET="${T}/$$.out" 388 # create a line of same length as input string
157 local PATCH_TARGET="${T}/$$.patch" 389 [[ -z $1 ]] && set "$(printf "%65s" '')"
158 local PATCH_SUFFIX="" 390 echo "${1//?/=}"
159 local SINGLE_PATCH="no" 391 }
160 local x=""
161 392
162 if [ "$#" -gt 1 ] 393 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
163 then 394
395 # First process options. We localize the EPATCH_OPTS setting
396 # from above so that we can pass it on in the loop below with
397 # any additional values the user has specified.
398 local EPATCH_OPTS=( ${EPATCH_OPTS[*]} )
399 while [[ $# -gt 0 ]] ; do
400 case $1 in
401 -*) EPATCH_OPTS+=( "$1" ) ;;
402 *) break ;;
403 esac
404 shift
405 done
406
407 # Let the rest of the code process one user arg at a time --
408 # each arg may expand into multiple patches, and each arg may
409 # need to start off with the default global EPATCH_xxx values
410 if [[ $# -gt 1 ]] ; then
164 local m="" 411 local m
165 einfo "${#} patches to apply..."
166 for m in "$@" ; do 412 for m in "$@" ; do
167 epatch "${m}" 413 epatch "${m}"
168 done 414 done
169 return 0 415 return 0
170 fi 416 fi
171 417
172 if [ -n "$1" -a -f "$1" ] 418 local SINGLE_PATCH="no"
173 then 419 # no args means process ${EPATCH_SOURCE}
420 [[ $# -eq 0 ]] && set -- "${EPATCH_SOURCE}"
421
422 if [[ -f $1 ]] ; then
174 SINGLE_PATCH="yes" 423 SINGLE_PATCH="yes"
175 424 set -- "$1"
176 local EPATCH_SOURCE="$1" 425 # Use the suffix from the single patch (localize it); the code
426 # below will find the suffix for us
177 local EPATCH_SUFFIX="${1##*\.}" 427 local EPATCH_SUFFIX=$1
178 428
179 elif [ -n "$1" -a -d "$1" ] 429 elif [[ -d $1 ]] ; then
180 then 430 # We have to force sorting to C so that the wildcard expansion is consistent #471666.
181 # Allow no extension if EPATCH_FORCE=yes ... used by vim for example ... 431 evar_push_set LC_COLLATE C
182 if [ "${EPATCH_FORCE}" = "yes" ] && [ -z "${EPATCH_SUFFIX}" ] 432 # Some people like to make dirs of patches w/out suffixes (vim).
433 set -- "$1"/*${EPATCH_SUFFIX:+."${EPATCH_SUFFIX}"}
434 evar_pop
435
436 elif [[ -f ${EPATCH_SOURCE}/$1 ]] ; then
437 # Re-use EPATCH_SOURCE as a search dir
438 epatch "${EPATCH_SOURCE}/$1"
439 return $?
440
441 else
442 # sanity check ... if it isn't a dir or file, wtf man ?
443 [[ $# -ne 0 ]] && EPATCH_SOURCE=$1
444 echo
445 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:"
446 eerror
447 eerror " ${EPATCH_SOURCE}"
448 eerror " ( ${EPATCH_SOURCE##*/} )"
449 echo
450 die "Cannot find \$EPATCH_SOURCE!"
451 fi
452
453 # Now that we know we're actually going to apply something, merge
454 # all of the patch options back in to a single variable for below.
455 EPATCH_OPTS="${EPATCH_COMMON_OPTS} ${EPATCH_OPTS[*]}"
456
457 local PIPE_CMD
458 case ${EPATCH_SUFFIX##*\.} in
459 xz) PIPE_CMD="xz -dc" ;;
460 lzma) PIPE_CMD="lzma -dc" ;;
461 bz2) PIPE_CMD="bzip2 -dc" ;;
462 gz|Z|z) PIPE_CMD="gzip -dc" ;;
463 ZIP|zip) PIPE_CMD="unzip -p" ;;
464 *) ;;
465 esac
466
467 [[ ${SINGLE_PATCH} == "no" ]] && einfo "${EPATCH_MULTI_MSG}"
468
469 local x
470 for x in "$@" ; do
471 # If the patch dir given contains subdirs, or our EPATCH_SUFFIX
472 # didn't match anything, ignore continue on
473 [[ ! -f ${x} ]] && continue
474
475 local patchname=${x##*/}
476
477 # Apply single patches, or forced sets of patches, or
478 # patches with ARCH dependant names.
479 # ???_arch_foo.patch
480 # Else, skip this input altogether
481 local a=${patchname#*_} # strip the ???_
482 a=${a%%_*} # strip the _foo.patch
483 if ! [[ ${SINGLE_PATCH} == "yes" || \
484 ${EPATCH_FORCE} == "yes" || \
485 ${a} == all || \
486 ${a} == ${ARCH} ]]
183 then 487 then
184 local EPATCH_SOURCE="$1/*" 488 continue
489 fi
490
491 # Let people filter things dynamically
492 if [[ -n ${EPATCH_EXCLUDE}${EPATCH_USER_EXCLUDE} ]] ; then
493 # let people use globs in the exclude
494 eshopts_push -o noglob
495
496 local ex
497 for ex in ${EPATCH_EXCLUDE} ; do
498 if [[ ${patchname} == ${ex} ]] ; then
499 einfo " Skipping ${patchname} due to EPATCH_EXCLUDE ..."
500 eshopts_pop
501 continue 2
502 fi
503 done
504
505 for ex in ${EPATCH_USER_EXCLUDE} ; do
506 if [[ ${patchname} == ${ex} ]] ; then
507 einfo " Skipping ${patchname} due to EPATCH_USER_EXCLUDE ..."
508 eshopts_pop
509 continue 2
510 fi
511 done
512
513 eshopts_pop
514 fi
515
516 if [[ ${SINGLE_PATCH} == "yes" ]] ; then
517 if [[ -n ${EPATCH_SINGLE_MSG} ]] ; then
518 einfo "${EPATCH_SINGLE_MSG}"
519 else
520 einfo "Applying ${patchname} ..."
521 fi
185 else 522 else
186 local EPATCH_SOURCE="$1/*.${EPATCH_SUFFIX}" 523 einfo " ${patchname} ..."
524 fi
525
526 # most of the time, there will only be one run per unique name,
527 # but if there are more, make sure we get unique log filenames
528 local STDERR_TARGET="${T}/${patchname}.out"
529 if [[ -e ${STDERR_TARGET} ]] ; then
530 STDERR_TARGET="${T}/${patchname}-$$.out"
531 fi
532
533 printf "***** %s *****\nPWD: %s\n\n" "${patchname}" "${PWD}" > "${STDERR_TARGET}"
534
535 # Decompress the patch if need be
536 local count=0
537 local PATCH_TARGET
538 if [[ -n ${PIPE_CMD} ]] ; then
539 PATCH_TARGET="${T}/$$.patch"
540 echo "PIPE_COMMAND: ${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> "${STDERR_TARGET}"
541
542 if ! (${PIPE_CMD} "${x}" > "${PATCH_TARGET}") >> "${STDERR_TARGET}" 2>&1 ; then
543 echo
544 eerror "Could not extract patch!"
545 #die "Could not extract patch!"
546 count=5
547 break
187 fi 548 fi
549 else
550 PATCH_TARGET=${x}
551 fi
552
553 # Check for absolute paths in patches. If sandbox is disabled,
554 # people could (accidently) patch files in the root filesystem.
555 # Or trigger other unpleasantries #237667. So disallow -p0 on
556 # such patches.
557 local abs_paths=$(egrep -n '^[-+]{3} /' "${PATCH_TARGET}" | awk '$2 != "/dev/null" { print }')
558 if [[ -n ${abs_paths} ]] ; then
559 count=1
560 printf "NOTE: skipping -p0 due to absolute paths in patch:\n%s\n" "${abs_paths}" >> "${STDERR_TARGET}"
561 fi
562 # Similar reason, but with relative paths.
563 local rel_paths=$(egrep -n '^[-+]{3} [^ ]*[.][.]/' "${PATCH_TARGET}")
564 if [[ -n ${rel_paths} ]] ; then
565 echo
566 eerror "Rejected Patch: ${patchname} !"
567 eerror " ( ${PATCH_TARGET} )"
568 eerror
569 eerror "Your patch uses relative paths '../':"
570 eerror "${rel_paths}"
571 echo
572 die "you need to fix the relative paths in patch"
573 fi
574
575 # Dynamically detect the correct -p# ... i'm lazy, so shoot me :/
576 local patch_cmd
577 # Handle aliased patch command #404447 #461568
578 local patch="patch"
579 eval $(alias patch 2>/dev/null | sed 's:^alias ::')
580 while [[ ${count} -lt 5 ]] ; do
581 patch_cmd="${patch} -p${count} ${EPATCH_OPTS}"
582
583 # Generate some useful debug info ...
584 (
585 _epatch_draw_line "***** ${patchname} *****"
586 echo
587 echo "PATCH COMMAND: ${patch_cmd} < '${PATCH_TARGET}'"
588 echo
589 _epatch_draw_line "***** ${patchname} *****"
590 ${patch_cmd} --dry-run -f < "${PATCH_TARGET}" 2>&1
591 ret=$?
592 echo
593 echo "patch program exited with status ${ret}"
594 exit ${ret}
595 ) >> "${STDERR_TARGET}"
596
597 if [ $? -eq 0 ] ; then
598 (
599 _epatch_draw_line "***** ${patchname} *****"
600 echo
601 echo "ACTUALLY APPLYING ${patchname} ..."
602 echo
603 _epatch_draw_line "***** ${patchname} *****"
604 ${patch_cmd} < "${PATCH_TARGET}" 2>&1
605 ret=$?
606 echo
607 echo "patch program exited with status ${ret}"
608 exit ${ret}
609 ) >> "${STDERR_TARGET}"
610
611 if [ $? -ne 0 ] ; then
612 echo
613 eerror "A dry-run of patch command succeeded, but actually"
614 eerror "applying the patch failed!"
615 #die "Real world sux compared to the dreamworld!"
616 count=5
617 fi
618 break
619 fi
620
621 : $(( count++ ))
622 done
623
624 # if we had to decompress the patch, delete the temp one
625 if [[ -n ${PIPE_CMD} ]] ; then
626 rm -f "${PATCH_TARGET}"
627 fi
628
629 if [[ ${count} -ge 5 ]] ; then
630 echo
631 eerror "Failed Patch: ${patchname} !"
632 eerror " ( ${PATCH_TARGET} )"
633 eerror
634 eerror "Include in your bugreport the contents of:"
635 eerror
636 eerror " ${STDERR_TARGET}"
637 echo
638 die "Failed Patch: ${patchname}!"
639 fi
640
641 # if everything worked, delete the full debug patch log
642 rm -f "${STDERR_TARGET}"
643
644 # then log away the exact stuff for people to review later
645 cat <<-EOF >> "${T}/epatch.log"
646 PATCH: ${x}
647 CMD: ${patch_cmd}
648 PWD: ${PWD}
649
650 EOF
651 eend 0
652 done
653
654 [[ ${SINGLE_PATCH} == "no" ]] && einfo "Done with patching"
655 : # everything worked
656}
657
658# @FUNCTION: epatch_user
659# @USAGE:
660# @DESCRIPTION:
661# Applies user-provided patches to the source tree. The patches are
662# taken from /etc/portage/patches/<CATEGORY>/<P-PR|P|PN>[:SLOT]/, where the first
663# of these three directories to exist will be the one to use, ignoring
664# any more general directories which might exist as well. They must end
665# in ".patch" to be applied.
666#
667# User patches are intended for quick testing of patches without ebuild
668# modifications, as well as for permanent customizations a user might
669# desire. Obviously, there can be no official support for arbitrarily
670# patched ebuilds. So whenever a build log in a bug report mentions that
671# user patches were applied, the user should be asked to reproduce the
672# problem without these.
673#
674# Not all ebuilds do call this function, so placing patches in the
675# stated directory might or might not work, depending on the package and
676# the eclasses it inherits and uses. It is safe to call the function
677# repeatedly, so it is always possible to add a call at the ebuild
678# level. The first call is the time when the patches will be
679# applied.
680#
681# Ideally, this function should be called after gentoo-specific patches
682# have been applied, so that their code can be modified as well, but
683# before calls to e.g. eautoreconf, as the user patches might affect
684# autotool input files as well.
685epatch_user() {
686 [[ $# -ne 0 ]] && die "epatch_user takes no options"
687
688 # Allow multiple calls to this function; ignore all but the first
689 local applied="${T}/epatch_user.log"
690 [[ -e ${applied} ]] && return 2
691
692 # don't clobber any EPATCH vars that the parent might want
693 local EPATCH_SOURCE check base=${PORTAGE_CONFIGROOT%/}/etc/portage/patches
694 for check in ${CATEGORY}/{${P}-${PR},${P},${PN}}{,:${SLOT}}; do
695 EPATCH_SOURCE=${base}/${CTARGET}/${check}
696 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${CHOST}/${check}
697 [[ -r ${EPATCH_SOURCE} ]] || EPATCH_SOURCE=${base}/${check}
698 if [[ -d ${EPATCH_SOURCE} ]] ; then
699 EPATCH_SOURCE=${EPATCH_SOURCE} \
700 EPATCH_SUFFIX="patch" \
701 EPATCH_FORCE="yes" \
702 EPATCH_MULTI_MSG="Applying user patches from ${EPATCH_SOURCE} ..." \
703 epatch
704 echo "${EPATCH_SOURCE}" > "${applied}"
705 return 0
706 fi
707 done
708 echo "none" > "${applied}"
709 return 1
710}
711
712# @FUNCTION: emktemp
713# @USAGE: [temp dir]
714# @DESCRIPTION:
715# Cheap replacement for when debianutils (and thus mktemp)
716# does not exist on the users system.
717emktemp() {
718 local exe="touch"
719 [[ $1 == -d ]] && exe="mkdir" && shift
720 local topdir=$1
721
722 if [[ -z ${topdir} ]] ; then
723 [[ -z ${T} ]] \
724 && topdir="/tmp" \
725 || topdir=${T}
726 fi
727
728 if ! type -P mktemp > /dev/null ; then
729 # system lacks `mktemp` so we have to fake it
730 local tmp=/
731 while [[ -e ${tmp} ]] ; do
732 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
733 done
734 ${exe} "${tmp}" || ${exe} -p "${tmp}"
735 echo "${tmp}"
188 else 736 else
189 if [ ! -d ${EPATCH_SOURCE} ] 737 # the args here will give slightly wierd names on BSD,
190 then 738 # but should produce a usable file on all userlands
191 if [ -n "$1" -a "${EPATCH_SOURCE}" = "${WORKDIR}/patch" ] 739 if [[ ${exe} == "touch" ]] ; then
192 then 740 TMPDIR="${topdir}" mktemp -t tmp.XXXXXXXXXX
193 EPATCH_SOURCE="$1" 741 else
742 TMPDIR="${topdir}" mktemp -dt tmp.XXXXXXXXXX
743 fi
744 fi
745}
746
747# @FUNCTION: edos2unix
748# @USAGE: <file> [more files ...]
749# @DESCRIPTION:
750# A handy replacement for dos2unix, recode, fixdos, etc... This allows you
751# to remove all of these text utilities from DEPEND variables because this
752# is a script based solution. Just give it a list of files to convert and
753# they will all be changed from the DOS CRLF format to the UNIX LF format.
754edos2unix() {
755 [[ $# -eq 0 ]] && return 0
756 sed -i 's/\r$//' -- "$@" || die
757}
758
759# @FUNCTION: make_desktop_entry
760# @USAGE: make_desktop_entry(<command>, [name], [icon], [type], [fields])
761# @DESCRIPTION:
762# Make a .desktop file.
763#
764# @CODE
765# binary: what command does the app run with ?
766# name: the name that will show up in the menu
767# icon: the icon to use in the menu entry
768# this can be relative (to /usr/share/pixmaps) or
769# a full path to an icon
770# type: what kind of application is this?
771# for categories:
772# http://standards.freedesktop.org/menu-spec/latest/apa.html
773# if unset, function tries to guess from package's category
774# fields: extra fields to append to the desktop file; a printf string
775# @CODE
776make_desktop_entry() {
777 [[ -z $1 ]] && die "make_desktop_entry: You must specify the executable"
778
779 local exec=${1}
780 local name=${2:-${PN}}
781 local icon=${3:-${PN}}
782 local type=${4}
783 local fields=${5}
784
785 if [[ -z ${type} ]] ; then
786 local catmaj=${CATEGORY%%-*}
787 local catmin=${CATEGORY##*-}
788 case ${catmaj} in
789 app)
790 case ${catmin} in
791 accessibility) type="Utility;Accessibility";;
792 admin) type=System;;
793 antivirus) type=System;;
794 arch) type="Utility;Archiving";;
795 backup) type="Utility;Archiving";;
796 cdr) type="AudioVideo;DiscBurning";;
797 dicts) type="Office;Dictionary";;
798 doc) type=Documentation;;
799 editors) type="Utility;TextEditor";;
800 emacs) type="Development;TextEditor";;
801 emulation) type="System;Emulator";;
802 laptop) type="Settings;HardwareSettings";;
803 office) type=Office;;
804 pda) type="Office;PDA";;
805 vim) type="Development;TextEditor";;
806 xemacs) type="Development;TextEditor";;
807 esac
808 ;;
809
810 dev)
811 type="Development"
812 ;;
813
814 games)
815 case ${catmin} in
816 action|fps) type=ActionGame;;
817 arcade) type=ArcadeGame;;
818 board) type=BoardGame;;
819 emulation) type=Emulator;;
820 kids) type=KidsGame;;
821 puzzle) type=LogicGame;;
822 roguelike) type=RolePlaying;;
823 rpg) type=RolePlaying;;
824 simulation) type=Simulation;;
825 sports) type=SportsGame;;
826 strategy) type=StrategyGame;;
827 esac
828 type="Game;${type}"
829 ;;
830
831 gnome)
832 type="Gnome;GTK"
833 ;;
834
835 kde)
836 type="KDE;Qt"
837 ;;
838
839 mail)
840 type="Network;Email"
841 ;;
842
843 media)
844 case ${catmin} in
845 gfx)
846 type=Graphics
847 ;;
848 *)
849 case ${catmin} in
850 radio) type=Tuner;;
851 sound) type=Audio;;
852 tv) type=TV;;
853 video) type=Video;;
854 esac
855 type="AudioVideo;${type}"
856 ;;
857 esac
858 ;;
859
860 net)
861 case ${catmin} in
862 dialup) type=Dialup;;
863 ftp) type=FileTransfer;;
864 im) type=InstantMessaging;;
865 irc) type=IRCClient;;
866 mail) type=Email;;
867 news) type=News;;
868 nntp) type=News;;
869 p2p) type=FileTransfer;;
870 voip) type=Telephony;;
871 esac
872 type="Network;${type}"
873 ;;
874
875 sci)
876 case ${catmin} in
877 astro*) type=Astronomy;;
878 bio*) type=Biology;;
879 calc*) type=Calculator;;
880 chem*) type=Chemistry;;
881 elec*) type=Electronics;;
882 geo*) type=Geology;;
883 math*) type=Math;;
884 physics) type=Physics;;
885 visual*) type=DataVisualization;;
886 esac
887 type="Education;Science;${type}"
888 ;;
889
890 sys)
891 type="System"
892 ;;
893
894 www)
895 case ${catmin} in
896 client) type=WebBrowser;;
897 esac
898 type="Network;${type}"
899 ;;
900
901 *)
902 type=
903 ;;
904 esac
905 fi
906 local slot=${SLOT%/*}
907 if [[ ${slot} == "0" ]] ; then
908 local desktop_name="${PN}"
909 else
910 local desktop_name="${PN}-${slot}"
911 fi
912 local desktop="${T}/$(echo ${exec} | sed 's:[[:space:]/:]:_:g')-${desktop_name}.desktop"
913 #local desktop=${T}/${exec%% *:-${desktop_name}}.desktop
914
915 # Don't append another ";" when a valid category value is provided.
916 type=${type%;}${type:+;}
917
918 eshopts_push -s extglob
919 if [[ -n ${icon} && ${icon} != /* ]] && [[ ${icon} == *.xpm || ${icon} == *.png || ${icon} == *.svg ]]; then
920 ewarn "As described in the Icon Theme Specification, icon file extensions are not"
921 ewarn "allowed in .desktop files if the value is not an absolute path."
922 icon=${icon%.@(xpm|png|svg)}
923 fi
924 eshopts_pop
925
926 cat <<-EOF > "${desktop}"
927 [Desktop Entry]
928 Name=${name}
929 Type=Application
930 Comment=${DESCRIPTION}
931 Exec=${exec}
932 TryExec=${exec%% *}
933 Icon=${icon}
934 Categories=${type}
935 EOF
936
937 if [[ ${fields:-=} != *=* ]] ; then
938 # 5th arg used to be value to Path=
939 ewarn "make_desktop_entry: update your 5th arg to read Path=${fields}"
940 fields="Path=${fields}"
941 fi
942 [[ -n ${fields} ]] && printf '%b\n' "${fields}" >> "${desktop}"
943
944 (
945 # wrap the env here so that the 'insinto' call
946 # doesn't corrupt the env of the caller
947 insinto /usr/share/applications
948 doins "${desktop}"
949 ) || die "installing desktop file failed"
950}
951
952# @FUNCTION: _eutils_eprefix_init
953# @INTERNAL
954# @DESCRIPTION:
955# Initialized prefix variables for EAPI<3.
956_eutils_eprefix_init() {
957 has "${EAPI:-0}" 0 1 2 && : ${ED:=${D}} ${EPREFIX:=} ${EROOT:=${ROOT}}
958}
959
960# @FUNCTION: validate_desktop_entries
961# @USAGE: [directories]
962# @MAINTAINER:
963# Carsten Lohrke <carlo@gentoo.org>
964# @DESCRIPTION:
965# Validate desktop entries using desktop-file-utils
966validate_desktop_entries() {
967 _eutils_eprefix_init
968 if [[ -x "${EPREFIX}"/usr/bin/desktop-file-validate ]] ; then
969 einfo "Checking desktop entry validity"
970 local directories=""
971 for d in /usr/share/applications $@ ; do
972 [[ -d ${ED}${d} ]] && directories="${directories} ${ED}${d}"
973 done
974 if [[ -n ${directories} ]] ; then
975 for FILE in $(find ${directories} -name "*\.desktop" \
976 -not -path '*.hidden*' | sort -u 2>/dev/null)
977 do
978 local temp=$(desktop-file-validate ${FILE} | grep -v "warning:" | \
979 sed -e "s|error: ||" -e "s|${FILE}:|--|g" )
980 [[ -n $temp ]] && elog ${temp/--/${FILE/${ED}/}:}
981 done
982 fi
983 echo ""
984 else
985 einfo "Passing desktop entry validity check. Install dev-util/desktop-file-utils, if you want to help to improve Gentoo."
986 fi
987}
988
989# @FUNCTION: make_session_desktop
990# @USAGE: <title> <command> [command args...]
991# @DESCRIPTION:
992# Make a GDM/KDM Session file. The title is the file to execute to start the
993# Window Manager. The command is the name of the Window Manager.
994#
995# You can set the name of the file via the ${wm} variable.
996make_session_desktop() {
997 [[ -z $1 ]] && eerror "$0: You must specify the title" && return 1
998 [[ -z $2 ]] && eerror "$0: You must specify the command" && return 1
999
1000 local title=$1
1001 local command=$2
1002 local desktop=${T}/${wm:-${PN}}.desktop
1003 shift 2
1004
1005 cat <<-EOF > "${desktop}"
1006 [Desktop Entry]
1007 Name=${title}
1008 Comment=This session logs you into ${title}
1009 Exec=${command} $*
1010 TryExec=${command}
1011 Type=XSession
1012 EOF
1013
1014 (
1015 # wrap the env here so that the 'insinto' call
1016 # doesn't corrupt the env of the caller
1017 insinto /usr/share/xsessions
1018 doins "${desktop}"
1019 )
1020}
1021
1022# @FUNCTION: domenu
1023# @USAGE: <menus>
1024# @DESCRIPTION:
1025# Install the list of .desktop menu files into the appropriate directory
1026# (/usr/share/applications).
1027domenu() {
1028 (
1029 # wrap the env here so that the 'insinto' call
1030 # doesn't corrupt the env of the caller
1031 local i j ret=0
1032 insinto /usr/share/applications
1033 for i in "$@" ; do
1034 if [[ -f ${i} ]] ; then
1035 doins "${i}"
1036 ((ret+=$?))
1037 elif [[ -d ${i} ]] ; then
1038 for j in "${i}"/*.desktop ; do
1039 doins "${j}"
1040 ((ret+=$?))
1041 done
1042 else
1043 ((++ret))
1044 fi
1045 done
1046 exit ${ret}
1047 )
1048}
1049
1050# @FUNCTION: newmenu
1051# @USAGE: <menu> <newname>
1052# @DESCRIPTION:
1053# Like all other new* functions, install the specified menu as newname.
1054newmenu() {
1055 (
1056 # wrap the env here so that the 'insinto' call
1057 # doesn't corrupt the env of the caller
1058 insinto /usr/share/applications
1059 newins "$@"
1060 )
1061}
1062
1063# @FUNCTION: _iconins
1064# @INTERNAL
1065# @DESCRIPTION:
1066# function for use in doicon and newicon
1067_iconins() {
1068 (
1069 # wrap the env here so that the 'insinto' call
1070 # doesn't corrupt the env of the caller
1071 local funcname=$1; shift
1072 local size dir
1073 local context=apps
1074 local theme=hicolor
1075
1076 while [[ $# -gt 0 ]] ; do
1077 case $1 in
1078 -s|--size)
1079 if [[ ${2%%x*}x${2%%x*} == "$2" ]] ; then
1080 size=${2%%x*}
1081 else
1082 size=${2}
194 fi 1083 fi
195 1084 case ${size} in
196 echo 1085 16|22|24|32|36|48|64|72|96|128|192|256)
197 eerror "Cannot find \$EPATCH_SOURCE! Value for \$EPATCH_SOURCE is:" 1086 size=${size}x${size};;
198 eerror 1087 scalable)
199 eerror " ${EPATCH_SOURCE}"
200 echo
201 die "Cannot find \$EPATCH_SOURCE!"
202 fi
203
204 local EPATCH_SOURCE="${EPATCH_SOURCE}/*.${EPATCH_SUFFIX}"
205 fi
206
207 case ${EPATCH_SUFFIX##*\.} in
208 bz2)
209 PIPE_CMD="bzip2 -dc"
210 PATCH_SUFFIX="bz2"
211 ;; 1088 ;;
212 gz|Z|z) 1089 *)
213 PIPE_CMD="gzip -dc" 1090 eerror "${size} is an unsupported icon size!"
214 PATCH_SUFFIX="gz" 1091 exit 1;;
215 ;; 1092 esac
216 ZIP|zip) 1093 shift 2;;
217 PIPE_CMD="unzip -p" 1094 -t|--theme)
218 PATCH_SUFFIX="zip" 1095 theme=${2}
219 ;; 1096 shift 2;;
1097 -c|--context)
1098 context=${2}
1099 shift 2;;
220 *) 1100 *)
221 PIPE_CMD="cat" 1101 if [[ -z ${size} ]] ; then
222 PATCH_SUFFIX="patch" 1102 insinto /usr/share/pixmaps
223 ;; 1103 else
224 esac 1104 insinto /usr/share/icons/${theme}/${size}/${context}
225
226 if [ "${SINGLE_PATCH}" = "no" ]
227 then
228 einfo "Applying various patches (bugfixes/updates)..."
229 fi
230 for x in ${EPATCH_SOURCE}
231 do
232 # New ARCH dependant patch naming scheme...
233 #
234 # ???_arch_foo.patch
235 #
236 if [ -f ${x} ] && \
237 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \
238 [ "${EPATCH_FORCE}" = "yes" ])
239 then
240 local count=0
241 local popts="${EPATCH_OPTS}"
242
243 if [ -n "${EPATCH_EXCLUDE}" ]
244 then
245 if [ "`eval echo \$\{EPATCH_EXCLUDE/${x##*/}\}`" != "${EPATCH_EXCLUDE}" ]
246 then
247 continue
248 fi
249 fi 1105 fi
250 1106
251 if [ "${SINGLE_PATCH}" = "yes" ] 1107 if [[ ${funcname} == doicon ]] ; then
252 then 1108 if [[ -f $1 ]] ; then
253 if [ -n "${EPATCH_SINGLE_MSG}" ] 1109 doins "${1}"
254 then 1110 elif [[ -d $1 ]] ; then
255 einfo "${EPATCH_SINGLE_MSG}" 1111 shopt -s nullglob
1112 doins "${1}"/*.{png,svg}
1113 shopt -u nullglob
256 else 1114 else
257 einfo "Applying ${x##*/}..." 1115 eerror "${1} is not a valid file/directory!"
1116 exit 1
258 fi 1117 fi
259 else 1118 else
260 einfo " ${x##*/}..." 1119 break
261 fi 1120 fi
262 1121 shift 1;;
263 echo "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 1122 esac
264 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
265
266 # Allow for prefix to differ ... im lazy, so shoot me :/
267 while [ "${count}" -lt 5 ]
268 do
269 # Generate some useful debug info ...
270 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
271 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
272
273 if [ "${PATCH_SUFFIX}" != "patch" ]
274 then
275 echo -n "PIPE_COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
276 echo "${PIPE_CMD} ${x} > ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
277 else
278 PATCH_TARGET="${x}"
279 fi
280
281 echo -n "PATCH COMMAND: " >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
282 echo "patch -p${count} ${popts} < ${PATCH_TARGET}" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
283
284 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
285 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
286
287 if [ "${PATCH_SUFFIX}" != "patch" ]
288 then
289 if ! (${PIPE_CMD} ${x} > ${PATCH_TARGET}) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
290 then
291 echo
292 eerror "Could not extract patch!"
293 #die "Could not extract patch!"
294 count=5
295 break
296 fi
297 fi
298
299 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/} 2>&1
300 then
301 draw_line "***** ${x##*/} *****" > ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
302 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
303 echo "ACTUALLY APPLYING ${x##*/}..." >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
304 echo >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
305 draw_line "***** ${x##*/} *****" >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
306
307 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real 2>&1
308
309 if [ "$?" -ne 0 ]
310 then
311 cat ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
312 echo
313 eerror "A dry-run of patch command succeeded, but actually"
314 eerror "applying the patch failed!"
315 #die "Real world sux compared to the dreamworld!"
316 count=5
317 fi
318
319 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}.real
320
321 break
322 fi
323
324 count=$((count + 1))
325 done
326
327 if [ "${PATCH_SUFFIX}" != "patch" ]
328 then
329 rm -f ${PATCH_TARGET}
330 fi
331
332 if [ "${count}" -eq 5 ]
333 then
334 echo
335 eerror "Failed Patch: ${x##*/}!"
336 eerror
337 eerror "Include in your bugreport the contents of:"
338 eerror
339 eerror " ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}"
340 echo
341 die "Failed Patch: ${x##*/}!"
342 fi
343
344 rm -f ${STDERR_TARGET%/*}/${x##*/}-${STDERR_TARGET##*/}
345
346 eend 0
347 fi
348 done 1123 done
349 if [ "${SINGLE_PATCH}" = "no" ] 1124 if [[ ${funcname} == newicon ]] ; then
350 then 1125 newins "$@"
351 einfo "Done with patching"
352 fi
353}
354
355# This function return true if we are using the NPTL pthreads
356# implementation.
357#
358# <azarah@gentoo.org> (06 March 2003)
359#
360
361have_NPTL() {
362
363 cat > ${T}/test-nptl.c <<-"END"
364 #define _XOPEN_SOURCE
365 #include <unistd.h>
366 #include <stdio.h>
367
368 int main()
369 {
370 char buf[255];
371 char *str = buf;
372
373 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
374 if (NULL != str) {
375 printf("%s\n", str);
376 if (NULL != strstr(str, "NPTL"))
377 return 0;
378 }
379
380 return 1;
381 }
382 END
383
384 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ... "
385 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
386 then
387 echo "yes"
388 einfon "Checking what PTHREADS implementation we have ... "
389 if ${T}/nptl
390 then
391 return 0
392 else
393 return 1
394 fi 1126 fi
395 else 1127 ) || die
396 echo "no"
397 fi
398
399 return 1
400} 1128}
401 1129
402# This function check how many cpu's are present, and then set 1130# @FUNCTION: doicon
403# -j in MAKEOPTS accordingly. 1131# @USAGE: [options] <icons>
1132# @DESCRIPTION:
1133# Install icon into the icon directory /usr/share/icons or into
1134# /usr/share/pixmaps if "--size" is not set.
1135# This is useful in conjunction with creating desktop/menu files.
404# 1136#
405# Thanks to nall <nall@gentoo.org> for this. 1137# @CODE
1138# options:
1139# -s, --size
1140# !!! must specify to install into /usr/share/icons/... !!!
1141# size of the icon, like 48 or 48x48
1142# supported icon sizes are:
1143# 16 22 24 32 36 48 64 72 96 128 192 256 scalable
1144# -c, --context
1145# defaults to "apps"
1146# -t, --theme
1147# defaults to "hicolor"
406# 1148#
407get_number_of_jobs() { 1149# icons: list of icons
408 local jobs=0
409
410 if [ ! -r /proc/cpuinfo ]
411 then
412 return 1
413 fi
414
415 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
416 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
417 then
418 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
419 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
420 ADMINPARAM="${ADMINPARAM/-j}"
421 fi
422
423 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
424
425 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
426 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
427 then
428 # these archs will always have "[Pp]rocessor"
429 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
430
431 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
432 then
433 # sparc always has "ncpus active"
434 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
435
436 elif [ "${ARCH}" = "alpha" ]
437 then
438 # alpha has "cpus active", but only when compiled with SMP
439 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
440 then
441 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
442 else
443 jobs=2
444 fi
445
446 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
447 then
448 # ppc has "processor", but only when compiled with SMP
449 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
450 then
451 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
452 else
453 jobs=2
454 fi
455 elif [ "${ARCH}" = "s390" ]
456 then
457 # s390 has "# processors : "
458 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
459 else
460 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
461 die "Unknown ARCH -- ${ARCH}!"
462 fi
463
464 # Make sure the number is valid ...
465 if [ "${jobs}" -lt 1 ]
466 then
467 jobs=1
468 fi
469
470 if [ -n "${ADMINPARAM}" ]
471 then
472 if [ "${jobs}" -gt "${ADMINPARAM}" ]
473 then
474 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge..."
475 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
476 else
477 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge..."
478 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
479 fi
480 fi
481}
482
483# Cheap replacement for when debianutils (and thus mktemp)
484# does not exist on the users system
485# vapier@gentoo.org
486# 1150#
487# Takes just 1 parameter (the directory to create tmpfile in) 1151# example 1: doicon foobar.png fuqbar.svg suckbar.png
488mymktemp() { 1152# results in: insinto /usr/share/pixmaps
489 local topdir="$1" 1153# doins foobar.png fuqbar.svg suckbar.png
490
491 [ -z "${topdir}" ] && topdir=/tmp
492 if [ "`which mktemp 2>/dev/null`" ]
493 then
494 mktemp -p ${topdir}
495 else
496 local tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}"
497 touch ${tmp}
498 echo ${tmp}
499 fi
500}
501
502# Small wrapper for getent (Linux) and nidump (Mac OS X)
503# used in enewuser()/enewgroup()
504# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
505# 1154#
506# egetent(database, key) 1155# example 2: doicon -s 48 foobar.png fuqbar.png blobbar.png
507egetent() { 1156# results in: insinto /usr/share/icons/hicolor/48x48/apps
508 if [ "${ARCH}" == "macos" ] ; then 1157# doins foobar.png fuqbar.png blobbar.png
509 case "$2" in 1158# @CODE
510 *[!0-9]*) # Non numeric 1159doicon() {
511 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 1160 _iconins ${FUNCNAME} "$@"
512 ;;
513 *) # Numeric
514 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
515 ;;
516 esac
517 else
518 getent $1 $2
519 fi
520} 1161}
521 1162
522# Simplify/standardize adding users to the system 1163# @FUNCTION: newicon
523# vapier@gentoo.org 1164# @USAGE: [options] <icon> <newname>
1165# @DESCRIPTION:
1166# Like doicon, install the specified icon as newname.
524# 1167#
525# enewuser(username, uid, shell, homedir, groups, extra options) 1168# @CODE
1169# example 1: newicon foobar.png NEWNAME.png
1170# results in: insinto /usr/share/pixmaps
1171# newins foobar.png NEWNAME.png
526# 1172#
527# Default values if you do not specify any: 1173# example 2: newicon -s 48 foobar.png NEWNAME.png
528# username: REQUIRED ! 1174# results in: insinto /usr/share/icons/hicolor/48x48/apps
529# uid: next available (see useradd(8)) 1175# newins foobar.png NEWNAME.png
530# note: pass -1 to get default behavior 1176# @CODE
531# shell: /bin/false 1177newicon() {
532# homedir: /dev/null 1178 _iconins ${FUNCNAME} "$@"
533# groups: none
534# extra: comment of 'added by portage for ${PN}'
535enewuser() {
536 # get the username
537 local euser="$1"; shift
538 if [ -z "${euser}" ]
539 then
540 eerror "No username specified !"
541 die "Cannot call enewuser without a username"
542 fi
543
544 # lets see if the username already exists
545 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ]
546 then
547 return 0
548 fi
549 einfo "Adding user '${euser}' to your system ..."
550
551 # options to pass to useradd
552 local opts=
553
554 # handle uid
555 local euid="$1"; shift
556 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ]
557 then
558 if [ "${euid}" -gt 0 ]
559 then
560 if [ ! -z "`egetent passwd ${euid}`" ]
561 then
562 euid="next"
563 fi
564 else
565 eerror "Userid given but is not greater than 0 !"
566 die "${euid} is not a valid UID"
567 fi
568 else
569 euid="next"
570 fi
571 if [ "${euid}" == "next" ]
572 then
573 local pwrange
574 if [ "${ARCH}" == "macos" ] ; then
575 pwrange="`jot 898 101`"
576 else
577 pwrange="`seq 101 999`"
578 fi
579 for euid in ${pwrange} ; do
580 [ -z "`egetent passwd ${euid}`" ] && break
581 done
582 fi
583 opts="${opts} -u ${euid}"
584 einfo " - Userid: ${euid}"
585
586 # handle shell
587 local eshell="$1"; shift
588 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ]
589 then
590 if [ ! -e "${eshell}" ]
591 then
592 eerror "A shell was specified but it does not exist !"
593 die "${eshell} does not exist"
594 fi
595 else
596 eshell="/bin/false"
597 fi
598 einfo " - Shell: ${eshell}"
599 opts="${opts} -s ${eshell}"
600
601 # handle homedir
602 local ehome="$1"; shift
603 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ]
604 then
605 ehome="/dev/null"
606 fi
607 einfo " - Home: ${ehome}"
608 opts="${opts} -d ${ehome}"
609
610 # handle groups
611 local egroups="$1"; shift
612 if [ ! -z "${egroups}" ]
613 then
614 local oldifs="${IFS}"
615 export IFS=","
616 for g in ${egroups}
617 do
618 if [ -z "`egetent group \"${g}\"`" ]
619 then
620 eerror "You must add group ${g} to the system first"
621 die "${g} is not a valid GID"
622 fi
623 done
624 export IFS="${oldifs}"
625 opts="${opts} -g ${egroups}"
626 else
627 egroups="(none)"
628 fi
629 einfo " - Groups: ${egroups}"
630
631 # handle extra and add the user
632 local eextra="$@"
633 local oldsandbox="${SANDBOX_ON}"
634 export SANDBOX_ON="0"
635 if [ "${ARCH}" == "macos" ];
636 then
637 ### Make the user
638 if [ -z "${eextra}" ]
639 then
640 dscl . create /users/${euser} uid ${euid}
641 dscl . create /users/${euser} shell ${eshell}
642 dscl . create /users/${euser} home ${ehome}
643 dscl . create /users/${euser} realname "added by portage for ${PN}"
644 ### Add the user to the groups specified
645 for g in ${egroups}
646 do
647 dscl . merge /groups/${g} users ${euser}
648 done
649 else
650 einfo "Extra options are not supported on macos yet"
651 einfo "Please report the ebuild along with the info below"
652 einfo "eextra: ${eextra}"
653 die "Required function missing"
654 fi
655 else
656 if [ -z "${eextra}" ]
657 then
658 useradd ${opts} ${euser} \
659 -c "added by portage for ${PN}" \
660 || die "enewuser failed"
661 else
662 einfo " - Extra: ${eextra}"
663 useradd ${opts} ${euser} ${eextra} \
664 || die "enewuser failed"
665 fi
666 fi
667 export SANDBOX_ON="${oldsandbox}"
668
669 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
670 then
671 einfo " - Creating ${ehome} in ${D}"
672 dodir ${ehome}
673 fowners ${euser} ${ehome}
674 fperms 755 ${ehome}
675 fi
676} 1179}
677 1180
678# Simplify/standardize adding groups to the system 1181# @FUNCTION: strip-linguas
679# vapier@gentoo.org 1182# @USAGE: [<allow LINGUAS>|<-i|-u> <directories of .po files>]
680# 1183# @DESCRIPTION:
681# enewgroup(group, gid)
682#
683# Default values if you do not specify any:
684# groupname: REQUIRED !
685# gid: next available (see groupadd(8))
686# extra: none
687enewgroup() {
688 # get the group
689 local egroup="$1"; shift
690 if [ -z "${egroup}" ]
691 then
692 eerror "No group specified !"
693 die "Cannot call enewgroup without a group"
694 fi
695
696 # see if group already exists
697 if [ "${egroup}" == "`egetent group \"${egroup}\" | cut -d: -f1`" ]
698 then
699 return 0
700 fi
701 einfo "Adding group '${egroup}' to your system ..."
702
703 # options to pass to useradd
704 local opts=
705
706 # handle gid
707 local egid="$1"; shift
708 if [ ! -z "${egid}" ]
709 then
710 if [ "${egid}" -gt 0 ]
711 then
712 if [ -z "`egetent group ${egid}`" ]
713 then
714 if [ "${ARCH}" == "macos" ] ; then
715 opts="${opts} ${egid}"
716 else
717 opts="${opts} -g ${egid}"
718 fi
719 else
720 egid="next available; requested gid taken"
721 fi
722 else
723 eerror "Groupid given but is not greater than 0 !"
724 die "${egid} is not a valid GID"
725 fi
726 else
727 egid="next available"
728 fi
729 einfo " - Groupid: ${egid}"
730
731 # handle extra
732 local eextra="$@"
733 opts="${opts} ${eextra}"
734
735 # add the group
736 local oldsandbox="${SANDBOX_ON}"
737 export SANDBOX_ON="0"
738 if [ "${ARCH}" == "macos" ];
739 then
740 if [ ! -z "${eextra}" ];
741 then
742 einfo "Extra options are not supported on macos yet"
743 einfo "Please report the ebuild along with the info below"
744 einfo "eextra: ${eextra}"
745 die "Required function missing"
746 fi
747
748 # If we need the next available
749 case ${egid} in
750 *[!0-9]*) # Non numeric
751 for egid in `jot 898 101`; do
752 [ -z "`egetent group ${egid}`" ] && break
753 done
754 esac
755 dscl . create /groups/${egroup} gid ${egid}
756 dscl . create /groups/${egroup} passwd '*'
757 else
758 groupadd ${opts} ${egroup} || die "enewgroup failed"
759 fi
760 export SANDBOX_ON="${oldsandbox}"
761}
762
763# Simple script to replace 'dos2unix' binaries
764# vapier@gentoo.org
765#
766# edos2unix(file, <more files>...)
767edos2unix() {
768 for f in "$@"
769 do
770 cp "${f}" ${T}/edos2unix
771 sed 's/\r$//' ${T}/edos2unix > "${f}"
772 done
773}
774
775# Make a desktop file !
776# Great for making those icons in kde/gnome startmenu !
777# Amaze your friends ! Get the women ! Join today !
778# gnome2 /usr/share/applications
779# gnome1 /usr/share/gnome/apps/
780# KDE ${KDEDIR}/share/applnk /usr/share/applnk
781#
782# make_desktop_entry(<binary>, [name], [icon], [type], [path])
783#
784# binary: what binary does the app run with ?
785# name: the name that will show up in the menu
786# icon: give your little like a pretty little icon ...
787# this can be relative (to /usr/share/pixmaps) or
788# a full path to an icon
789# type: what kind of application is this ? for categories:
790# http://www.freedesktop.org/standards/menu-spec/
791# path: if your app needs to startup in a specific dir
792make_desktop_entry() {
793 [ -z "$1" ] && eerror "You must specify the executable" && return 1
794
795 local exec="${1}"
796 local name="${2:-${PN}}"
797 local icon="${3:-${PN}.png}"
798 local type="${4}"
799 local subdir="${6}"
800 local path="${5:-${GAMES_PREFIX}}"
801 if [ -z "${type}" ]
802 then
803 case ${CATEGORY} in
804 "app-emulation")
805 type=Emulator
806 subdir="Emulation"
807 ;;
808 "games-"*)
809 type=Game
810 subdir="Games"
811 ;;
812 "net-"*)
813 type=Network
814 subdir="${type}"
815 ;;
816 *)
817 type=
818 subdir=
819 ;;
820 esac
821 fi
822 local desktop="${T}/${exec}.desktop"
823
824echo "[Desktop Entry]
825Encoding=UTF-8
826Version=0.9.2
827Name=${name}
828Type=Application
829Comment=${DESCRIPTION}
830Exec=${exec}
831Path=${path}
832Icon=${icon}
833Categories=Application;${type};" > ${desktop}
834
835 if [ -d "/usr/share/applications" ]
836 then
837 insinto /usr/share/applications
838 doins ${desktop}
839 fi
840
841 #if [ -d "/usr/share/gnome/apps" ]
842 #then
843 # insinto /usr/share/gnome/apps/Games
844 # doins ${desktop}
845 #fi
846
847 #if [ ! -z "`ls /usr/kde/* 2>/dev/null`" ]
848 #then
849 # for ver in /usr/kde/*
850 # do
851 # insinto ${ver}/share/applnk/Games
852 # doins ${desktop}
853 # done
854 #fi
855
856 if [ -d "/usr/share/applnk" ]
857 then
858 insinto /usr/share/applnk/${subdir}
859 doins ${desktop}
860 fi
861
862 return 0
863}
864
865# for internal use only (unpack_pdv and unpack_makeself)
866find_unpackable_file() {
867 local src="$1"
868 if [ -z "${src}" ]
869 then
870 src="${DISTDIR}/${A}"
871 else
872 if [ -e "${DISTDIR}/${src}" ]
873 then
874 src="${DISTDIR}/${src}"
875 elif [ -e "${PWD}/${src}" ]
876 then
877 src="${PWD}/${src}"
878 elif [ -e "${src}" ]
879 then
880 src="${src}"
881 fi
882 fi
883 [ ! -e "${src}" ] && die "Could not find requested archive ${src}"
884 echo "${src}"
885}
886
887# Unpack those pesky pdv generated files ...
888# They're self-unpacking programs with the binary package stuffed in
889# the middle of the archive. Valve seems to use it a lot ... too bad
890# it seems to like to segfault a lot :(. So lets take it apart ourselves.
891#
892# Usage: unpack_pdv [file to unpack] [size of off_t]
893# - you have to specify the off_t size ... i have no idea how to extract that
894# information out of the binary executable myself. basically you pass in
895# the size of the off_t type (in bytes) on the machine that built the pdv
896# archive. one way to determine this is by running the following commands:
897# strings <pdv archive> | grep lseek
898# strace -elseek <pdv archive>
899# basically look for the first lseek command (we do the strings/grep because
900# sometimes the function call is _llseek or something) and steal the 2nd
901# parameter. here is an example:
902# root@vapier 0 pdv_unpack # strings hldsupdatetool.bin | grep lseek
903# lseek
904# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
905# lseek(3, -4, SEEK_END) = 2981250
906# thus we would pass in the value of '4' as the second parameter.
907unpack_pdv() {
908 local src="`find_unpackable_file $1`"
909 local sizeoff_t="$2"
910
911 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :("
912
913 local shrtsrc="`basename ${src}`"
914 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
915 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
916 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
917
918 # grab metadata for debug reasons
919 local metafile="`mymktemp ${T}`"
920 tail -c +$((${metaskip}+1)) ${src} > ${metafile}
921
922 # rip out the final file name from the metadata
923 local datafile="`tail -c +$((${metaskip}+1)) ${src} | strings | head -n 1`"
924 datafile="`basename ${datafile}`"
925
926 # now lets uncompress/untar the file if need be
927 local tmpfile="`mymktemp ${T}`"
928 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null | head -c 512 > ${tmpfile}
929
930 local iscompressed="`file -b ${tmpfile}`"
931 if [ "${iscompressed:0:8}" == "compress" ] ; then
932 iscompressed=1
933 mv ${tmpfile}{,.Z}
934 gunzip ${tmpfile}
935 else
936 iscompressed=0
937 fi
938 local istar="`file -b ${tmpfile}`"
939 if [ "${istar:0:9}" == "POSIX tar" ] ; then
940 istar=1
941 else
942 istar=0
943 fi
944
945 #for some reason gzip dies with this ... dd cant provide buffer fast enough ?
946 #dd if=${src} ibs=${metaskip} count=1 \
947 # | dd ibs=${tailskip} skip=1 \
948 # | gzip -dc \
949 # > ${datafile}
950 if [ ${iscompressed} -eq 1 ] ; then
951 if [ ${istar} -eq 1 ] ; then
952 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
953 | head -c $((${metaskip}-${tailskip})) \
954 | tar -xzf -
955 else
956 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
957 | head -c $((${metaskip}-${tailskip})) \
958 | gzip -dc \
959 > ${datafile}
960 fi
961 else
962 if [ ${istar} -eq 1 ] ; then
963 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
964 | head -c $((${metaskip}-${tailskip})) \
965 | tar --no-same-owner -xf -
966 else
967 tail -c +$((${tailskip}+1)) ${src} 2>/dev/null \
968 | head -c $((${metaskip}-${tailskip})) \
969 > ${datafile}
970 fi
971 fi
972 true
973 #[ -s "${datafile}" ] || die "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
974 #assert "failure unpacking pdv ('${metaskip}' '${tailskip}' '${datafile}')"
975}
976
977# Unpack those pesky makeself generated files ...
978# They're shell scripts with the binary package tagged onto
979# the end of the archive. Loki utilized the format as does
980# many other game companies.
981#
982# Usage: unpack_makeself [file to unpack] [offset]
983# - If the file is not specified then unpack will utilize ${A}.
984# - If the offset is not specified then we will attempt to extract
985# the proper offset from the script itself.
986unpack_makeself() {
987 local src="`find_unpackable_file $1`"
988 local skip="$2"
989
990 local shrtsrc="`basename ${src}`"
991 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
992 if [ -z "${skip}" ]
993 then
994 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`"
995 local skip=0
996 case ${ver} in
997 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
998 skip=`grep -a ^skip= ${src} | cut -d= -f2`
999 ;;
1000 2.0|2.0.1)
1001 skip=`grep -a ^$'\t'tail ${src} | awk '{print $2}' | cut -b2-`
1002 ;;
1003 2.1.1)
1004 skip=`grep -a ^offset= ${src} | awk '{print $2}' | cut -b2-`
1005 let skip="skip + 1"
1006 ;;
1007 2.1.2)
1008 skip=`grep -a ^offset= ${src} | awk '{print $3}' | head -n 1`
1009 let skip="skip + 1"
1010 ;;
1011 2.1.3)
1012 skip=`grep -a ^offset= ${src} | awk '{print $3}'`
1013 let skip="skip + 1"
1014 ;;
1015 *)
1016 eerror "I'm sorry, but I was unable to support the Makeself file."
1017 eerror "The version I detected was '${ver}'."
1018 eerror "Please file a bug about the file ${shrtsrc} at"
1019 eerror "http://bugs.gentoo.org/ so that support can be added."
1020 die "makeself version '${ver}' not supported"
1021 ;;
1022 esac
1023 debug-print "Detected Makeself version ${ver} ... using ${skip} as offset"
1024 fi
1025
1026 # lets grab the first few bytes of the file to figure out what kind of archive it is
1027 local tmpfile="`mymktemp ${T}`"
1028 tail -n +${skip} ${src} 2>/dev/null | head -c 512 > ${tmpfile}
1029 local filetype="`file -b ${tmpfile}`"
1030 case ${filetype} in
1031 *tar\ archive)
1032 tail -n +${skip} ${src} | tar --no-same-owner -xf -
1033 ;;
1034 bzip2*)
1035 tail -n +${skip} ${src} | bzip2 -dc | tar --no-same-owner -xf -
1036 ;;
1037 gzip*)
1038 tail -n +${skip} ${src} | tar --no-same-owner -xzf -
1039 ;;
1040 compress*)
1041 tail -n +${skip} ${src} | gunzip | tar --no-same-owner -xf -
1042 ;;
1043 *)
1044 eerror "Unknown filetype \"${filetype}\" ?"
1045 false
1046 ;;
1047 esac
1048 assert "failure unpacking (${filetype}) makeself ${shrtsrc} ('${ver}' +${skip})"
1049}
1050
1051# Display a license for user to accept.
1052#
1053# Usage: check_license [license]
1054# - If the file is not specified then ${LICENSE} is used.
1055check_license() {
1056 local lic=$1
1057 if [ -z "${lic}" ] ; then
1058 lic="${PORTDIR}/licenses/${LICENSE}"
1059 else
1060 if [ -e "${PORTDIR}/licenses/${src}" ] ; then
1061 lic="${PORTDIR}/licenses/${src}"
1062 elif [ -e "${PWD}/${src}" ] ; then
1063 lic="${PWD}/${src}"
1064 elif [ -e "${src}" ] ; then
1065 lic="${src}"
1066 fi
1067 fi
1068 [ ! -f "${lic}" ] && die "Could not find requested license ${src}"
1069 local l="`basename ${lic}`"
1070
1071 # here is where we check for the licenses the user already
1072 # accepted ... if we don't find a match, we make the user accept
1073 local alic
1074 for alic in "${ACCEPT_LICENSE}" ; do
1075 [ "${alic}" == "*" ] && return 0
1076 [ "${alic}" == "${l}" ] && return 0
1077 done
1078
1079 local licmsg="`mymktemp ${T}`"
1080 cat << EOF > ${licmsg}
1081**********************************************************
1082The following license outlines the terms of use of this
1083package. You MUST accept this license for installation to
1084continue. When you are done viewing, hit 'q'. If you
1085CTRL+C out of this, the install will not run!
1086**********************************************************
1087
1088EOF
1089 cat ${lic} >> ${licmsg}
1090 ${PAGER:-less} ${licmsg} || die "Could not execute pager (${PAGER}) to accept ${lic}"
1091 einfon "Do you accept the terms of this license (${l})? [yes/no] "
1092 read alic
1093 case ${alic} in
1094 yes|Yes|y|Y)
1095 return 0
1096 ;;
1097 *)
1098 echo;echo;echo
1099 eerror "You MUST accept the license to continue! Exiting!"
1100 die "Failed to accept license"
1101 ;;
1102 esac
1103}
1104
1105# Aquire cd(s) for those lovely cd-based emerges. Yes, this violates
1106# the whole 'non-interactive' policy, but damnit I want CD support !
1107#
1108# with these cdrom functions we handle all the user interaction and
1109# standardize everything. all you have to do is call cdrom_get_cds()
1110# and when the function returns, you can assume that the cd has been
1111# found at CDROM_ROOT.
1112#
1113# normally the cdrom functions will refer to the cds as 'cd #1', 'cd #2',
1114# etc... if you want to give the cds better names, then just export
1115# the CDROM_NAME_X variables before calling cdrom_get_cds().
1116#
1117# for those multi cd ebuilds, see the cdrom_load_next_cd() below.
1118#
1119# Usage: cdrom_get_cds <file on cd1> [file on cd2] [file on cd3] [...]
1120# - this will attempt to locate a cd based upon a file that is on
1121# the cd ... the more files you give this function, the more cds
1122# the cdrom functions will handle
1123cdrom_get_cds() {
1124 # first we figure out how many cds we're dealing with by
1125 # the # of files they gave us
1126 local cdcnt=0
1127 local f=
1128 for f in "$@" ; do
1129 cdcnt=$((cdcnt + 1))
1130 export CDROM_CHECK_${cdcnt}="$f"
1131 done
1132 export CDROM_TOTAL_CDS=${cdcnt}
1133 export CDROM_CURRENT_CD=1
1134
1135 # now we see if the user gave use CD_ROOT ...
1136 # if they did, let's just believe them that it's correct
1137 if [ ! -z "${CD_ROOT}" ] ; then
1138 export CDROM_ROOT="${CD_ROOT}"
1139 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1140 return
1141 fi
1142 # do the same for CD_ROOT_X
1143 if [ ! -z "${CD_ROOT_1}" ] ; then
1144 local var=
1145 cdcnt=0
1146 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1147 cdcnt=$((cdcnt + 1))
1148 var="CD_ROOT_${cdcnt}"
1149 if [ -z "${!var}" ] ; then
1150 eerror "You must either use just the CD_ROOT"
1151 eerror "or specify ALL the CD_ROOT_X variables."
1152 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1153 die "could not locate CD_ROOT_${cdcnt}"
1154 fi
1155 export CDROM_ROOTS_${cdcnt}="${!var}"
1156 done
1157 export CDROM_ROOT=${CDROM_ROOTS_1}
1158 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1159 return
1160 fi
1161
1162 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1163 einfon "This ebuild will need the "
1164 if [ -z "${CDROM_NAME}" ] ; then
1165 echo "cdrom for ${PN}."
1166 else
1167 echo "${CDROM_NAME}."
1168 fi
1169 echo
1170 einfo "If you do not have the CD, but have the data files"
1171 einfo "mounted somewhere on your filesystem, just export"
1172 einfo "the variable CD_ROOT so that it points to the"
1173 einfo "directory containing the files."
1174 echo
1175 else
1176 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1177 cdcnt=0
1178 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1179 cdcnt=$((cdcnt + 1))
1180 var="CDROM_NAME_${cdcnt}"
1181 [ ! -z "${!var}" ] && einfo " CD ${cdcnt}: ${!var}"
1182 done
1183 echo
1184 einfo "If you do not have the CDs, but have the data files"
1185 einfo "mounted somewhere on your filesystem, just export"
1186 einfo "the following variables so they point to the right place:"
1187 einfon ""
1188 cdcnt=0
1189 while [ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ] ; do
1190 cdcnt=$((cdcnt + 1))
1191 echo -n " CD_ROOT_${cdcnt}"
1192 done
1193 echo
1194 einfo "Or, if you have all the files in the same place, or"
1195 einfo "you only have one cdrom, you can export CD_ROOT"
1196 einfo "and that place will be used as the same data source"
1197 einfo "for all the CDs."
1198 echo
1199 fi
1200 export CDROM_CURRENT_CD=0
1201 cdrom_load_next_cd
1202}
1203
1204# this is only used when you need access to more than one cd.
1205# when you have finished using the first cd, just call this function.
1206# when it returns, CDROM_ROOT will be pointing to the second cd.
1207# remember, you can only go forward in the cd chain, you can't go back.
1208cdrom_load_next_cd() {
1209 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1210 local var=
1211
1212 if [ ! -z "${CD_ROOT}" ] ; then
1213 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1214 return
1215 fi
1216
1217 unset CDROM_ROOT
1218 var=CDROM_ROOTS_${CDROM_CURRENT_CD}
1219 if [ -z "${!var}" ] ; then
1220 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1221 cdrom_locate_file_on_cd ${!var}
1222 else
1223 export CDROM_ROOT="${!var}"
1224 fi
1225
1226 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1227}
1228
1229# this is used internally by the cdrom_get_cds() and cdrom_load_next_cd()
1230# functions. this should *never* be called from an ebuild.
1231# all it does is try to locate a give file on a cd ... if the cd isn't
1232# found, then a message asking for the user to insert the cdrom will be
1233# displayed and we'll hang out here until:
1234# (1) the file is found on a mounted cdrom
1235# (2) the user hits CTRL+C
1236cdrom_locate_file_on_cd() {
1237 while [ -z "${CDROM_ROOT}" ] ; do
1238 local dir="$(dirname ${@})"
1239 local file="$(basename ${@})"
1240 local mline=""
1241 local showedmsg=0
1242
1243 for mline in `mount | egrep -e '(iso|cdrom)' | awk '{print $3}'` ; do
1244 [ -d "${mline}/${dir}" ] || continue
1245 [ ! -z "$(find ${mline}/${dir} -iname ${file} -maxdepth 1)" ] \
1246 && export CDROM_ROOT=${mline}
1247 done
1248
1249 if [ -z "${CDROM_ROOT}" ] ; then
1250 echo
1251 if [ ${showedmsg} -eq 0 ] ; then
1252 if [ ${CDROM_TOTAL_CDS} -eq 1 ] ; then
1253 if [ -z "${CDROM_NAME}" ] ; then
1254 einfo "Please insert the cdrom for ${PN} now !"
1255 else
1256 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1257 fi
1258 else
1259 if [ -z "${CDROM_NAME_1}" ] ; then
1260 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1261 else
1262 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1263 einfo "Please insert+mount the ${!var} cdrom now !"
1264 fi
1265 fi
1266 showedmsg=1
1267 fi
1268 einfo "Press return to scan for the cd again"
1269 einfo "or hit CTRL+C to abort the emerge."
1270 read
1271 fi
1272 done
1273}
1274
1275# Make sure that LINGUAS only contains languages that 1184# Make sure that LINGUAS only contains languages that
1276# a package can support 1185# a package can support. The first form allows you to
1277# 1186# specify a list of LINGUAS. The -i builds a list of po
1278# usage: strip-linguas <allow LINGUAS> 1187# files found in all the directories and uses the
1279# strip-linguas -i <directories of .po files> 1188# intersection of the lists. The -u builds a list of po
1280# strip-linguas -u <directories of .po files> 1189# files found in all the directories and uses the union
1281# 1190# of the lists.
1282# The first form allows you to specify a list of LINGUAS.
1283# The -i builds a list of po files found in all the
1284# directories and uses the intersection of the lists.
1285# The -u builds a list of po files found in all the
1286# directories and uses the union of the lists.
1287strip-linguas() { 1191strip-linguas() {
1288 local ls newls 1192 local ls newls nols
1289 if [ "$1" == "-i" ] || [ "$1" == "-u" ] ; then 1193 if [[ $1 == "-i" ]] || [[ $1 == "-u" ]] ; then
1290 local op="$1"; shift 1194 local op=$1; shift
1291 ls=" $(find "$1" -name '*.po' -printf '%f ') "; shift 1195 ls=$(find "$1" -name '*.po' -exec basename {} .po ';'); shift
1292 local d f 1196 local d f
1293 for d in "$@" ; do 1197 for d in "$@" ; do
1294 if [ "${op}" == "-u" ] ; then 1198 if [[ ${op} == "-u" ]] ; then
1295 newls="${ls}" 1199 newls=${ls}
1296 else 1200 else
1297 newls="" 1201 newls=""
1298 fi 1202 fi
1299 for f in $(find "$d" -name '*.po' -printf '%f ') ; do 1203 for f in $(find "$d" -name '*.po' -exec basename {} .po ';') ; do
1300 if [ "${op}" == "-i" ] ; then 1204 if [[ ${op} == "-i" ]] ; then
1301 [ "${ls/ ${f} /}" != "${ls}" ] && newls="${newls} ${f}" 1205 has ${f} ${ls} && newls="${newls} ${f}"
1302 else 1206 else
1303 [ "${ls/ ${f} /}" == "${ls}" ] && newls="${newls} ${f}" 1207 has ${f} ${ls} || newls="${newls} ${f}"
1304 fi 1208 fi
1305 done 1209 done
1306 ls="${newls}" 1210 ls=${newls}
1307 done 1211 done
1308 ls="${ls//.po}"
1309 else 1212 else
1310 ls="$@" 1213 ls="$@"
1311 fi 1214 fi
1312 1215
1313 ls=" ${ls} " 1216 nols=""
1314 newls="" 1217 newls=""
1315 for f in ${LINGUAS} ; do 1218 for f in ${LINGUAS} ; do
1316 if [ "${ls/ ${f} /}" != "${ls}" ] ; then 1219 if has ${f} ${ls} ; then
1317 nl="${newls} ${f}" 1220 newls="${newls} ${f}"
1318 else 1221 else
1319 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1222 nols="${nols} ${f}"
1320 fi 1223 fi
1321 done 1224 done
1322 if [ -z "${newls}" ] ; then 1225 [[ -n ${nols} ]] \
1323 unset LINGUAS 1226 && einfo "Sorry, but ${PN} does not support the LINGUAS:" ${nols}
1227 export LINGUAS=${newls:1}
1228}
1229
1230# @FUNCTION: preserve_old_lib
1231# @USAGE: <libs to preserve> [more libs]
1232# @DESCRIPTION:
1233# These functions are useful when a lib in your package changes ABI SONAME.
1234# An example might be from libogg.so.0 to libogg.so.1. Removing libogg.so.0
1235# would break packages that link against it. Most people get around this
1236# by using the portage SLOT mechanism, but that is not always a relevant
1237# solution, so instead you can call this from pkg_preinst. See also the
1238# preserve_old_lib_notify function.
1239preserve_old_lib() {
1240 _eutils_eprefix_init
1241 if [[ ${EBUILD_PHASE} != "preinst" ]] ; then
1242 eerror "preserve_old_lib() must be called from pkg_preinst() only"
1243 die "Invalid preserve_old_lib() usage"
1244 fi
1245 [[ -z $1 ]] && die "Usage: preserve_old_lib <library to preserve> [more libraries to preserve]"
1246
1247 # let portage worry about it
1248 has preserve-libs ${FEATURES} && return 0
1249
1250 local lib dir
1251 for lib in "$@" ; do
1252 [[ -e ${EROOT}/${lib} ]] || continue
1253 dir=${lib%/*}
1254 dodir ${dir} || die "dodir ${dir} failed"
1255 cp "${EROOT}"/${lib} "${ED}"/${lib} || die "cp ${lib} failed"
1256 touch "${ED}"/${lib}
1257 done
1258}
1259
1260# @FUNCTION: preserve_old_lib_notify
1261# @USAGE: <libs to notify> [more libs]
1262# @DESCRIPTION:
1263# Spit helpful messages about the libraries preserved by preserve_old_lib.
1264preserve_old_lib_notify() {
1265 if [[ ${EBUILD_PHASE} != "postinst" ]] ; then
1266 eerror "preserve_old_lib_notify() must be called from pkg_postinst() only"
1267 die "Invalid preserve_old_lib_notify() usage"
1268 fi
1269
1270 # let portage worry about it
1271 has preserve-libs ${FEATURES} && return 0
1272
1273 _eutils_eprefix_init
1274
1275 local lib notice=0
1276 for lib in "$@" ; do
1277 [[ -e ${EROOT}/${lib} ]] || continue
1278 if [[ ${notice} -eq 0 ]] ; then
1279 notice=1
1280 ewarn "Old versions of installed libraries were detected on your system."
1281 ewarn "In order to avoid breaking packages that depend on these old libs,"
1282 ewarn "the libraries are not being removed. You need to run revdep-rebuild"
1283 ewarn "in order to remove these old dependencies. If you do not have this"
1284 ewarn "helper program, simply emerge the 'gentoolkit' package."
1285 ewarn
1286 fi
1287 ewarn " # revdep-rebuild --library '${lib}' && rm '${lib}'"
1288 done
1289}
1290
1291# @FUNCTION: built_with_use
1292# @USAGE: [--hidden] [--missing <action>] [-a|-o] <DEPEND ATOM> <List of USE flags>
1293# @DESCRIPTION:
1294#
1295# Deprecated: Use EAPI 2 use deps in DEPEND|RDEPEND and with has_version calls.
1296#
1297# A temporary hack until portage properly supports DEPENDing on USE
1298# flags being enabled in packages. This will check to see if the specified
1299# DEPEND atom was built with the specified list of USE flags. The
1300# --missing option controls the behavior if called on a package that does
1301# not actually support the defined USE flags (aka listed in IUSE).
1302# The default is to abort (call die). The -a and -o flags control
1303# the requirements of the USE flags. They correspond to "and" and "or"
1304# logic. So the -a flag means all listed USE flags must be enabled
1305# while the -o flag means at least one of the listed IUSE flags must be
1306# enabled. The --hidden option is really for internal use only as it
1307# means the USE flag we're checking is hidden expanded, so it won't be found
1308# in IUSE like normal USE flags.
1309#
1310# Remember that this function isn't terribly intelligent so order of optional
1311# flags matter.
1312built_with_use() {
1313 _eutils_eprefix_init
1314 local hidden="no"
1315 if [[ $1 == "--hidden" ]] ; then
1316 hidden="yes"
1317 shift
1318 fi
1319
1320 local missing_action="die"
1321 if [[ $1 == "--missing" ]] ; then
1322 missing_action=$2
1323 shift ; shift
1324 case ${missing_action} in
1325 true|false|die) ;;
1326 *) die "unknown action '${missing_action}'";;
1327 esac
1328 fi
1329
1330 local opt=$1
1331 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1332
1333 local PKG=$(best_version $1)
1334 [[ -z ${PKG} ]] && die "Unable to resolve $1 to an installed package"
1335 shift
1336
1337 local USEFILE=${EROOT}/var/db/pkg/${PKG}/USE
1338 local IUSEFILE=${EROOT}/var/db/pkg/${PKG}/IUSE
1339
1340 # if the IUSE file doesn't exist, the read will error out, we need to handle
1341 # this gracefully
1342 if [[ ! -e ${USEFILE} ]] || [[ ! -e ${IUSEFILE} && ${hidden} == "no" ]] ; then
1343 case ${missing_action} in
1344 true) return 0;;
1345 false) return 1;;
1346 die) die "Unable to determine what USE flags $PKG was built with";;
1347 esac
1348 fi
1349
1350 if [[ ${hidden} == "no" ]] ; then
1351 local IUSE_BUILT=( $(<"${IUSEFILE}") )
1352 # Don't check USE_EXPAND #147237
1353 local expand
1354 for expand in $(echo ${USE_EXPAND} | tr '[:upper:]' '[:lower:]') ; do
1355 if [[ $1 == ${expand}_* ]] ; then
1356 expand=""
1357 break
1358 fi
1359 done
1360 if [[ -n ${expand} ]] ; then
1361 if ! has $1 ${IUSE_BUILT[@]#[-+]} ; then
1362 case ${missing_action} in
1363 true) return 0;;
1364 false) return 1;;
1365 die) die "$PKG does not actually support the $1 USE flag!";;
1366 esac
1367 fi
1368 fi
1369 fi
1370
1371 local USE_BUILT=$(<${USEFILE})
1372 while [[ $# -gt 0 ]] ; do
1373 if [[ ${opt} = "-o" ]] ; then
1374 has $1 ${USE_BUILT} && return 0
1375 else
1376 has $1 ${USE_BUILT} || return 1
1377 fi
1378 shift
1379 done
1380 [[ ${opt} = "-a" ]]
1381}
1382
1383# @FUNCTION: epunt_cxx
1384# @USAGE: [dir to scan]
1385# @DESCRIPTION:
1386# Many configure scripts wrongly bail when a C++ compiler could not be
1387# detected. If dir is not specified, then it defaults to ${S}.
1388#
1389# http://bugs.gentoo.org/73450
1390epunt_cxx() {
1391 local dir=$1
1392 [[ -z ${dir} ]] && dir=${S}
1393 ebegin "Removing useless C++ checks"
1394 local f p any_found
1395 while IFS= read -r -d '' f; do
1396 for p in "${PORTDIR}"/eclass/ELT-patches/nocxx/*.patch ; do
1397 if patch --no-backup-if-mismatch -p1 "${f}" "${p}" >/dev/null ; then
1398 any_found=1
1399 break
1400 fi
1401 done
1402 done < <(find "${dir}" -name configure -print0)
1403
1404 if [[ -z ${any_found} ]]; then
1405 eqawarn "epunt_cxx called unnecessarily (no C++ checks to punt)."
1406 fi
1407 eend 0
1408}
1409
1410# @FUNCTION: make_wrapper
1411# @USAGE: <wrapper> <target> [chdir] [libpaths] [installpath]
1412# @DESCRIPTION:
1413# Create a shell wrapper script named wrapper in installpath
1414# (defaults to the bindir) to execute target (default of wrapper) by
1415# first optionally setting LD_LIBRARY_PATH to the colon-delimited
1416# libpaths followed by optionally changing directory to chdir.
1417make_wrapper() {
1418 _eutils_eprefix_init
1419 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1420 local tmpwrapper=$(emktemp)
1421
1422 (
1423 echo '#!/bin/sh'
1424 [[ -n ${chdir} ]] && printf 'cd "%s"\n' "${EPREFIX}${chdir}"
1425 if [[ -n ${libdir} ]] ; then
1426 local var
1427 if [[ ${CHOST} == *-darwin* ]] ; then
1428 var=DYLD_LIBRARY_PATH
1429 else
1430 var=LD_LIBRARY_PATH
1431 fi
1432 cat <<-EOF
1433 if [ "\${${var}+set}" = "set" ] ; then
1434 export ${var}="\${${var}}:${EPREFIX}${libdir}"
1435 else
1436 export ${var}="${EPREFIX}${libdir}"
1437 fi
1438 EOF
1439 fi
1440 # We don't want to quote ${bin} so that people can pass complex
1441 # things as ${bin} ... "./someprog --args"
1442 printf 'exec %s "$@"\n' "${bin/#\//${EPREFIX}/}"
1443 ) > "${tmpwrapper}"
1444 chmod go+rx "${tmpwrapper}"
1445
1446 if [[ -n ${path} ]] ; then
1447 (
1448 exeinto "${path}"
1449 newexe "${tmpwrapper}" "${wrapper}"
1450 ) || die
1324 else 1451 else
1325 export LINGUAS="${newls}" 1452 newbin "${tmpwrapper}" "${wrapper}" || die
1453 fi
1454}
1455
1456# @FUNCTION: path_exists
1457# @USAGE: [-a|-o] <paths>
1458# @DESCRIPTION:
1459# Check if the specified paths exist. Works for all types of paths
1460# (files/dirs/etc...). The -a and -o flags control the requirements
1461# of the paths. They correspond to "and" and "or" logic. So the -a
1462# flag means all the paths must exist while the -o flag means at least
1463# one of the paths must exist. The default behavior is "and". If no
1464# paths are specified, then the return value is "false".
1465path_exists() {
1466 local opt=$1
1467 [[ ${opt} == -[ao] ]] && shift || opt="-a"
1468
1469 # no paths -> return false
1470 # same behavior as: [[ -e "" ]]
1471 [[ $# -eq 0 ]] && return 1
1472
1473 local p r=0
1474 for p in "$@" ; do
1475 [[ -e ${p} ]]
1476 : $(( r += $? ))
1477 done
1478
1479 case ${opt} in
1480 -a) return $(( r != 0 )) ;;
1481 -o) return $(( r == $# )) ;;
1482 esac
1483}
1484
1485# @FUNCTION: in_iuse
1486# @USAGE: <flag>
1487# @DESCRIPTION:
1488# Determines whether the given flag is in IUSE. Strips IUSE default prefixes
1489# as necessary.
1490#
1491# Note that this function should not be used in the global scope.
1492in_iuse() {
1493 debug-print-function ${FUNCNAME} "${@}"
1494 [[ ${#} -eq 1 ]] || die "Invalid args to ${FUNCNAME}()"
1495
1496 local flag=${1}
1497 local liuse=( ${IUSE} )
1498
1499 has "${flag}" "${liuse[@]#[+-]}"
1500}
1501
1502# @FUNCTION: use_if_iuse
1503# @USAGE: <flag>
1504# @DESCRIPTION:
1505# Return true if the given flag is in USE and IUSE.
1506#
1507# Note that this function should not be used in the global scope.
1508use_if_iuse() {
1509 in_iuse $1 || return 1
1510 use $1
1511}
1512
1513# @FUNCTION: usex
1514# @USAGE: <USE flag> [true output] [false output] [true suffix] [false suffix]
1515# @DESCRIPTION:
1516# Proxy to declare usex for package managers or EAPIs that do not provide it
1517# and use the package manager implementation when available (i.e. EAPI >= 5).
1518# If USE flag is set, echo [true output][true suffix] (defaults to "yes"),
1519# otherwise echo [false output][false suffix] (defaults to "no").
1520if has "${EAPI:-0}" 0 1 2 3 4; then
1521 usex() { use "$1" && echo "${2-yes}$4" || echo "${3-no}$5" ; } #382963
1522fi
1523
1524# @FUNCTION: prune_libtool_files
1525# @USAGE: [--all|--modules]
1526# @DESCRIPTION:
1527# Locate unnecessary libtool files (.la) and libtool static archives
1528# (.a) and remove them from installation image.
1529#
1530# By default, .la files are removed whenever the static linkage can
1531# either be performed using pkg-config or doesn't introduce additional
1532# flags.
1533#
1534# If '--modules' argument is passed, .la files for modules (plugins) are
1535# removed as well. This is usually useful when the package installs
1536# plugins and the plugin loader does not use .la files.
1537#
1538# If '--all' argument is passed, all .la files are removed without
1539# performing any heuristic on them. You shouldn't ever use that,
1540# and instead report a bug in the algorithm instead.
1541#
1542# The .a files are only removed whenever corresponding .la files state
1543# that they should not be linked to, i.e. whenever these files
1544# correspond to plugins.
1545#
1546# Note: if your package installs both static libraries and .pc files
1547# which use variable substitution for -l flags, you need to add
1548# pkg-config to your DEPEND.
1549prune_libtool_files() {
1550 debug-print-function ${FUNCNAME} "$@"
1551
1552 local removing_all removing_modules opt
1553 _eutils_eprefix_init
1554 for opt; do
1555 case "${opt}" in
1556 --all)
1557 removing_all=1
1558 removing_modules=1
1559 ;;
1560 --modules)
1561 removing_modules=1
1562 ;;
1563 *)
1564 die "Invalid argument to ${FUNCNAME}(): ${opt}"
1565 esac
1566 done
1567
1568 local f
1569 local queue=()
1570 while IFS= read -r -d '' f; do # for all .la files
1571 local archivefile=${f/%.la/.a}
1572
1573 # The following check is done by libtool itself.
1574 # It helps us avoid removing random files which match '*.la',
1575 # see bug #468380.
1576 if ! sed -n -e '/^# Generated by .*libtool/q0;4q1' "${f}"; then
1577 continue
1326 fi 1578 fi
1579
1580 [[ ${f} != ${archivefile} ]] || die 'regex sanity check failed'
1581 local reason pkgconfig_scanned
1582 local snotlink=$(sed -n -e 's:^shouldnotlink=::p' "${f}")
1583
1584 if [[ ${snotlink} == yes ]]; then
1585
1586 # Remove static libs we're not supposed to link against.
1587 if [[ -f ${archivefile} ]]; then
1588 einfo "Removing unnecessary ${archivefile#${D%/}} (static plugin)"
1589 queue+=( "${archivefile}" )
1590 fi
1591
1592 # The .la file may be used by a module loader, so avoid removing it
1593 # unless explicitly requested.
1594 if [[ ${removing_modules} ]]; then
1595 reason='module'
1596 fi
1597
1598 else
1599
1600 # Remove .la files when:
1601 # - user explicitly wants us to remove all .la files,
1602 # - respective static archive doesn't exist,
1603 # - they are covered by a .pc file already,
1604 # - they don't provide any new information (no libs & no flags).
1605
1606 if [[ ${removing_all} ]]; then
1607 reason='requested'
1608 elif [[ ! -f ${archivefile} ]]; then
1609 reason='no static archive'
1610 elif [[ ! $(sed -nre \
1611 "s/^(dependency_libs|inherited_linker_flags)='(.*)'$/\2/p" \
1612 "${f}") ]]; then
1613 reason='no libs & flags'
1614 else
1615 if [[ ! ${pkgconfig_scanned} ]]; then
1616 # Create a list of all .pc-covered libs.
1617 local pc_libs=()
1618 if [[ ! ${removing_all} ]]; then
1619 local pc
1620 local tf=${T}/prune-lt-files.pc
1621 local pkgconf=$(tc-getPKG_CONFIG)
1622
1623 while IFS= read -r -d '' pc; do # for all .pc files
1624 local arg libs
1625
1626 # Use pkg-config if available (and works),
1627 # fallback to sed.
1628 if ${pkgconf} --exists "${pc}" &>/dev/null; then
1629 sed -e '/^Requires:/d' "${pc}" > "${tf}"
1630 libs=$(${pkgconf} --libs "${tf}")
1631 else
1632 libs=$(sed -ne 's/^Libs://p' "${pc}")
1633 fi
1634
1635 for arg in ${libs}; do
1636 if [[ ${arg} == -l* ]]; then
1637 if [[ ${arg} == '*$*' ]]; then
1638 eqawarn "${FUNCNAME}: variable substitution likely failed in ${pc}"
1639 eqawarn "(arg: ${arg})"
1640 eqawarn "Most likely, you need to add virtual/pkgconfig to DEPEND."
1641 fi
1642
1643 pc_libs+=( lib${arg#-l}.la )
1644 fi
1645 done
1646 done < <(find "${D}" -type f -name '*.pc' -print0)
1647
1648 rm -f "${tf}"
1649 fi
1650
1651 pkgconfig_scanned=1
1652 fi # pkgconfig_scanned
1653
1654 has "${f##*/}" "${pc_libs[@]}" && reason='covered by .pc'
1655 fi # removal due to .pc
1656
1657 fi # shouldnotlink==no
1658
1659 if [[ ${reason} ]]; then
1660 einfo "Removing unnecessary ${f#${D%/}} (${reason})"
1661 queue+=( "${f}" )
1662 fi
1663 done < <(find "${ED}" -xtype f -name '*.la' -print0)
1664
1665 if [[ ${queue[@]} ]]; then
1666 rm -f "${queue[@]}"
1667 fi
1327} 1668}
1669
1670# @FUNCTION: einstalldocs
1671# @DESCRIPTION:
1672# Install documentation using DOCS and HTML_DOCS.
1673#
1674# If DOCS is declared and non-empty, all files listed in it are
1675# installed. The files must exist, otherwise the function will fail.
1676# In EAPI 4 and subsequent EAPIs DOCS may specify directories as well,
1677# in other EAPIs using directories is unsupported.
1678#
1679# If DOCS is not declared, the files matching patterns given
1680# in the default EAPI implementation of src_install will be installed.
1681# If this is undesired, DOCS can be set to empty value to prevent any
1682# documentation from being installed.
1683#
1684# If HTML_DOCS is declared and non-empty, all files and/or directories
1685# listed in it are installed as HTML docs (using dohtml).
1686#
1687# Both DOCS and HTML_DOCS can either be an array or a whitespace-
1688# separated list. Whenever directories are allowed, '<directory>/.' may
1689# be specified in order to install all files within the directory
1690# without creating a sub-directory in docdir.
1691#
1692# Passing additional options to dodoc and dohtml is not supported.
1693# If you needed such a thing, you need to call those helpers explicitly.
1694einstalldocs() {
1695 debug-print-function ${FUNCNAME} "${@}"
1696
1697 local dodoc_opts=-r
1698 has ${EAPI} 0 1 2 3 && dodoc_opts=
1699
1700 if ! declare -p DOCS &>/dev/null ; then
1701 local d
1702 for d in README* ChangeLog AUTHORS NEWS TODO CHANGES \
1703 THANKS BUGS FAQ CREDITS CHANGELOG ; do
1704 if [[ -s ${d} ]] ; then
1705 dodoc "${d}" || die
1706 fi
1707 done
1708 elif [[ $(declare -p DOCS) == "declare -a"* ]] ; then
1709 if [[ ${DOCS[@]} ]] ; then
1710 dodoc ${dodoc_opts} "${DOCS[@]}" || die
1711 fi
1712 else
1713 if [[ ${DOCS} ]] ; then
1714 dodoc ${dodoc_opts} ${DOCS} || die
1715 fi
1716 fi
1717
1718 if [[ $(declare -p HTML_DOCS 2>/dev/null) == "declare -a"* ]] ; then
1719 if [[ ${HTML_DOCS[@]} ]] ; then
1720 dohtml -r "${HTML_DOCS[@]}" || die
1721 fi
1722 else
1723 if [[ ${HTML_DOCS} ]] ; then
1724 dohtml -r ${HTML_DOCS} || die
1725 fi
1726 fi
1727
1728 return 0
1729}
1730
1731check_license() { die "you no longer need this as portage supports ACCEPT_LICENSE itself"; }
1732
1733# @FUNCTION: optfeature
1734# @USAGE: <short description> <package atom to match> [other atoms]
1735# @DESCRIPTION:
1736# Print out a message suggesting an optional package (or packages) which
1737# provide the described functionality
1738#
1739# The following snippet would suggest app-misc/foo for optional foo support,
1740# app-misc/bar or app-misc/baz[bar] for optional bar support
1741# and either both app-misc/a and app-misc/b or app-misc/c for alphabet support.
1742# @CODE
1743# optfeature "foo support" app-misc/foo
1744# optfeature "bar support" app-misc/bar app-misc/baz[bar]
1745# optfeature "alphabet support" "app-misc/a app-misc/b" app-misc/c
1746# @CODE
1747optfeature() {
1748 debug-print-function ${FUNCNAME} "$@"
1749 local i j msg
1750 local desc=$1
1751 local flag=0
1752 shift
1753 for i; do
1754 for j in ${i}; do
1755 if has_version "${j}"; then
1756 flag=1
1757 else
1758 flag=0
1759 break
1760 fi
1761 done
1762 if [[ ${flag} -eq 1 ]]; then
1763 break
1764 fi
1765 done
1766 if [[ ${flag} -eq 0 ]]; then
1767 for i; do
1768 msg=" "
1769 for j in ${i}; do
1770 msg+=" ${j} and"
1771 done
1772 msg="${msg:0: -4} for ${desc}"
1773 elog "${msg}"
1774 done
1775 fi
1776}
1777
1778fi

Legend:
Removed from v.1.96  
changed lines
  Added in v.1.440

  ViewVC Help
Powered by ViewVC 1.1.20